*****************************************************
*                     MAND3CSI                      *
*           441.5 octets  cksum # 422Ch             *
*                                                   *
* Extension du programme MANDELGT permettant de     *
* traiter 2 fois plus rapidement les ensembles de   *
* Mandelbrot lorsqu'il y a symtrie (Yc = 0)        *
* et d'afficher des pixels fonction de la parit du *
* du nombre d'itrations avec la possibilit de     *
* stopper le programme sans arrt systme           *
*                                                   *
*    Auteur : Guy Toublanc      le 21/4/94          *
*                                                   *
* fichier source compilable sur PC par RPLCOMP de HP*
* ou sur HP48 avec ->RPL de D. Mueller (en mettant  *
* en majuscules les mnmoniques de l'assembleur     *
***************************************************** 
* arguments et notations :                          *
*  arguments :                                      *
*               niveau 3 : ( Xc,Yc)   1 complexe    *
*               niveau 2 : ( Px,Py)   1 complexe    *
*               niveau 1 :  iter      1 rel        *
*  Xc,Yc: coordonnes du centre de l'image          *
*  Px,Py: pas d'avancement en abscisses et ordonnes*
*  iter : nombres d'itrations de                   *
*          Z(i+1) = Z(i)^2 + Z                      *
*          avec Z(i) = ( Xz(i),Yz(i) )  (boucle Z)  *
*               Z = (Xz,Yz)   pour le point courant *
*         si iter est ngatif un troisime ensemble *
*         de pixels sera affich                    *
* principe de dpart:                               *
*          iter,Xc,Yc,Px,Py sont multiplis par     *
*          108576 = # 100000h puis convertis en     *
*          entiers binaires signs pour les calculs *
*          en virgule fixe : hhh....h , hhhhh       *
*          pour ces arguments tous les calculs se   *
*          feront suivant ce mode sauf pour iter    *
*          qui aprs dtermination de son signe     *
*          reprendra sa valeur sans signe           *
*                                                   *
* les autres variables :                            *
*                                                   *
*  Xzo,Yzo cordonnes du 1er pixel de la 1re ligne *
*  Xi,Yi coordonnes du 1er point de chaque ligne   *
*                                        (boucle I) *
*  Xj abscisse du point courant d'une ligne         *
*                                        (boucle J) *
*  Xz,Yz coordonnes du point courant pour le dpart*
*  de l'itration de la boucle Z                    *
*  Xz(i),Yz(i) voir ci-dessus                       *           
*                                                   *
* principe gnral :                                *
*     chaque ligne est parcourue de gauche  droite *
*     par la boucle J, pour chaque point on fait n  *
*     itrations (iter) pour calculer Z(i) avec la  *
*     boucle Z :                                    *
*       si abs(Z(i) >= 2 alors sortie de boucle     *
*         avec 2 cas pour le nombre d'itrations k: *
*               si k pair alors PIXON               *
*               sinon point suivant                 *
*       sinon aprs les n itrations on fait PIXON  *
*     le balayage (de haut en bas) des 64 lignes    *
*     effectu par la boucle I ou des 33 lignes     *
*     hautes jusqu' l'axe de symtrie si Yc = 0    *
*                                                   *
* intgration dans la boucle principale I d'un test *
* d'appui de la touche [ATTN]/[CANCEL] pour sortie  *
* de programme sans destruction de PICT             *
*                                                   *
* pour commencer : conversion des donnes en entiers*
* binaires stocks dans un entier binaire long de   *
* 5*16 digits                                       *
*                                                   *
*****************************************************

::
 CK3&Dispatch # 221              
 ::
  '                              
   ::                            
    MINUSONE UNCOERCE %1+ %* DUP 
    %0 %< ITE :: %CHS %># HXS 1  
                 0 SWAP bit- ;   
              %>#  SWAP          
   ;
  DUP4UNROLL EVAL C%>%     
  4PICK EVAL                     
  4PICK EVAL &HXS &HXS ROT C%>% 
  4PICK EVAL                     
  4ROLL EVAL &HXS &HXS           
  SIXTYFOUR BINT_131d MAKEGROB   
  GROB>GDISP ZEROZERO WINDOW#    

*************************************************
* niveau 1 : entier binaire contenant:          *
*            iter , Px , Py , Xc , Yc           *
*            soit 5*16 quartets de donnes      *
*************************************************

CODE

=out<c>in  EQU  #01eec
     
        gosbvl  =PopASavptr
        gosbvl  =DisableIntr
        d1=a            * @ l'entier binaire
        d0=(5)  #01f79
        a=dat0  a
        d0=a
        a=dat0  a
        d0=a            * @ PICT
        d0=d0+  16      * saute prolog. long. dims
        d0=d0+  4       * et @ dbut donnes PICT
        c=0     w
        p=      4
        cpex    5
        d=c     w       * d(w) := # 400000h : limite
        d1=d1+  10      * @ iter
        c=dat1  w
        clrst           * pour non symtrie et 
        ?c=0    s       * iter positif
        goyes   twocolors
        st=1    0       * pour 3 couleurs
        c=-c    w       * valeur absolue de iter
twocolors
        gosbvl  =CSRW5  * vraie valeur de iter
        c=c-1   a       * iter - 1
        rstk=c          * sauve iter sur rstk
        d1=d1+  12      * @ index lignes I
        lc(2)   63      * 64 -1 lignes pour loopx
        dat1=c  b       * index lignes I
        cd1ex
        r0=c            * sauve @ index I
        cd1ex           * restaure d1 et c(a)
        d1=d1+  4       * saute index absc., @ Px
        a=dat1  w       * Px
        b=a     w
loopx   a=a+b   w       * pour 65*Px et calcul Xzo
        c=c-1   b
        gonc    loopx
        d1=d1+  16      * @ Yp
        lc(2)   30
        d=c     b       * index boucle y
        c=dat1  w       * Yp
        b=c     w
loopy   b=b+c   w       * pour 32*Py et calcul Yzo
        d=d-1   b
        gonc    loopy
        d1=d1+  16      * @ Xc
        c=dat1  w       * Xc
        c=c-a   w       * Xc - 65*Px
        dat1=c  w       * Xzo dbut de ligne
        d1=d1+  16      * @ Yc
        a=dat1  w       * Yc
        d1=d1-  16      * @ sauvegarde Xzo 
        ?a#0    w       * Yc <> 0 ?
        goyes   calcYzo * oui alors non symtrie
        st=1    1       * pour symtrie verticale
        cr0ex           * c(a) := adr. I   r0 := Xzo
        cd1ex           * c(a) := adr. Xzo d1 @ I
        rstk=c          * sauve adr. Xzo
        lc(2)   32      * (n lignes  balayer) - 1
        dat1=c  b       * index I
        c=rstk          * rcupre adr. Xzo
        d1=c            * d1 @ Xzo
        c=r0            * Xzo
calcYzo a=a+b   w       * Yzo = Yc + 32*Py

*****************************************************
* d1 @ Xzo     d1- 16  Py    d1- 32 Px            *
*              d1- 36  index lignes (I=63 ou 32)   *
*              d1- 34  index abscisses (J)         *
* iter sur rstk   p= 0   r0 := Xzo    r1 := Yzo     *
* d(w) := 4 000..h     d(b) index pour boucle Z     *
* d0 @ dbut donnes du pict                        *
* a(w) := Yi = Yzo     c := Xj = Xzo                *
*****************************************************

loopI   r1=a            * Yi
        r0=c            * Xj = Xzo
        r2=c            * Xz(i)
        d1=d1-  16      * @ Py
        d1=d1-  16      * @ Px
        d1=d1-  2       * @ index J abscisses
        lc(2)   130     * (131 - 1) pixels
        dat1=c  b       * index J pixels
        d=0     xs      * position pixel dans nib.
        d=d+1   xs      * initialisation
loopJ

*****************************************************
* d1 @ J   d(xs) = 1 index position dans le quartet *
*                    et pour incrmenter d0         *
* p= 0          J = 130   r0  r1  r2  r3 actualiss *
* d0 @ dbut ligne I                                *
*****************************************************

        c=rstk
        d=c     b       * index itrations
        rstk=c
loopZ

*****************************************************
* calcul Xz(i)^2   Yz(i)^2  2Xz(i)*Yz(i)            *
* entre :                                          *
*          d1 @ J                                   *
* principe :                                        *
*          si ( Z(i)^2 ) >= 4 donc abs(Z(i)) >= 2 : *
*          sortie pour le pixel suivant de la ligne *
*          sinon PIXON                              *
*****************************************************

        r3=a           * Yz(i) -> r3(w)
        gosub   sqr    * a(w) := Yz(i)^2
        r4=a           * Yz(i)^2 -> r4(w)
        a=r2           * Xz(i)
        gosub   sqr    * a(w) := Xz(i)^2
        c=r4           * Yz(i)^2
        c=c+a   w      * Xz(i)^2 + Yz(i)^2
        ?c<d    w      * limite non dpasse ?
        goyes   cont   * oui on continue
        ?st=0   0      * non alors 2 couleurs ?
        goyes   nopixon
        c=d     b      * nombre d'itrations  faire
        ?cbit=0 0      * parit paire ?
        goyes   nopixon
        gonc    pixon  * non alors PIXON
cont    c=r4           * Yz(i)^2
        a=a-c   w      * Xz(i)^2 - Yz(i)^2
        c=r0           * Xz
        a=a+c   w      * Xz(i+1)
        ar2ex          * Xz(i+1) -> r2  a(w) := Xz(i)
        a=a+a   w      * 2*Xz(i)
        c=r3           * Yz(i)
        gosub   mpy    * 2*Xz(i)*Yz(i)
        c=r1           * Yz
        a=a+c   w      * Yz(i+1)         (-> r3)
nextZ   d=d-1   b      * index iter
        gonc    loopZ

pixon   c=dat0  xs     * quartet contenant le pixel
        c=c!d   xs     * OR pour noircir le pixel
        dat0=c  xs     * remet en place le quartet
nopixon d=d+d   xs     * pour position pixel suivant
        gonc    idnib  * si pas encore position 3
        d0=d0+  1      * aprs bit 0 -> 1 -> 2 ->
        d=d+1   xs     * bit 3 on revient  bit 0
*                      * et on avance d'un quartet  
idnib   c=dat1  b      * index J
        c=c-1   b
        goc     outJ   * on sort de la boucle J
        dat1=c  b      * sinon sauve index J
        d1=d1+  2      * @ Px
        a=r0           * X(j)
        c=dat1  w      * Px
        c=a+c   w      * X(j+1) = X(j) + Px
        r0=c           * X(j+1) -> r0
        r2=c           * Xz(i) = X(j+1)
        a=r1           * Yz -> Yz(i)      (-> r3)
        d1=d1-  2      * @ index J
nextJ   goto    loopJ

outJ    d0=d0+  2      * nib 34  puis ligne I + 1
        d1=d1-  2      * @ index I
        c=dat1  b      * index I
        c=c-1   b      * I - 1
        goc     ?sym   * test avant sortie gnrale ?
        dat1=c  b      * sinon sauve index I
        d1=d1+  4      * saute les 2 index
        d1=d1+  16     * @ Py
        gosbvl  =out<c>in
        ?cbit=1 15     * appui de [ATTN]/[CANCEL] ?
        goyes   out    * oui alors sortie gnrale
        a=r1           * Y(i)
        c=dat1  w      * Py
        a=a-c   w      * Y(i+1) = Y(i) - Py (->r1/r3)
        d1=d1+  16     * @ Xzo
        c=dat1  w      * Xzo
nextI   goto    loopI  * a:= Y(i+1) c:= Xzo d1 @ Xzo
?sym    ?st=0   1      * non symtrie ?
        goyes   out    * oui alors sortie gnrale
        ad0ex
        d0=a           * @ dbut ligne sous axe
        c=0     a
        lc(2)   29     * n-1 lignes  symtriser
        d=c     a      * index lignes
        lc(2)   (2*34) * offset pour reculer au
        b=c     a      * dbut ligne au-dessus
looprow a=a-b   a      * ligne au-dessus
        d1=a           * @  -     -
        lc(2)   16     * (m-1) octets par ligne
loop2nib
        a=dat1  b      * octet du grob au-dessus axe
        dat0=a  b      * symtrise 8 pixels  la fois
        d0=d0+  2      * 8 pixels ou octet suivant
        d1=d1+  2      *         dito
        c=c-1   b      * index d'octets - 1
        gonc    loop2nib
        ad1ex          * a := adr. fin ligne copie
        d=d-1   a      * index de lignes - 1
        gonc    looprow
out     c=rstk         * enlve iter de la rstk
        gosbvl  =AllowIntr * autorise les interrupt.
        govlng  =GETPTRLOOP * retour au Rpl

*****************************************************
* produit de 2 nombres <  2 en valeur absolue      *
* en entre : a(w) & c(w) les 2 nombres  multiplier*
*                                                   *
* en sortie :  a(w) = a*c    c(w) = 0               *
*****************************************************

sqr     c=a     w       * pour le carr
mpy     st=0    2       * pour le signe
        ?a=0    s       * positif ?
        goyes   apos    * oui alors test autre fact.
        a=-a    w       * sinon valeur absolue
        st=1    2       * pour ngatif
apos    ?c=0    s       * positif ?
        goyes   mpy0    * oui alors produit
        c=-c    w       * sinon valeur absolue
        ?st=1   2       * 1er facteur ngatif ?
        goyes   neg     * alors produit positif
        st=1    2       * sinon produit ngatif
        gonc    mpy0    * saut pour le produit
neg     st=0    2       * pour produit positif
mpy0    b=0     w       * initialisation produit
        abex    w       * a(w) prod. b(w) muliplican.
mpy1    sb=0            * pour bit 0 nul
        csrb            * divise par 2
        ?sb=0           * bit 0 nul ?
        goyes   mpy2    * alors produit inchang
        a=a+b   w       * sinon produit partiel
mpy2    b=b+b   w       * multiplicande * 2
        ?c#0    w       * reste bits multiplicateur ?
        goyes   mpy1    * oui on itration
        gosbvl  =ASRW5  * sinon divise par # 100000h
        ?st=0   2       * produit positif
        rtnyes          * oui retour
        a=-a    w       * sinon entier sign
        rtn
ENDCODE
  GBUFF                 
 ;                      
;
