/*****************************************************************************/
/*****************************************************************************/
/**                             VMEM95.C                                    **/
/**               Visualisation dynamique de la mmoire                     **/
/**                                                                         **/
/**   Cration : 20/09/91                          Auteur : Jacques Belin   **/
/**   Dernire modification : 16/05/92                                      **/
/**    Ajout de msg_box()                                                   **/
/**                                                                         **/
/**  Note : Dvelopp et test uniquement sur Turbo C++ 1.01                **/
/**         TASM ncessaire (pour l'assemblage en ligne)                    **/
/*****************************************************************************/
/*****************************************************************************/
#pragma inline                          /*  Autorisation assemblage en ligne */

#include <stdio.h>
#include <dos.h>
#include <io.h>
#include <conio.h>
#include <fcntl.h>
#include <stdlib.h>
#include <string.h>
#include <bios.h>
#include <ctype.h>


/*--------- Codes de quelques touches tels que GETKEY() les renvoie ---------*/
#define ESC     27                                  /* Code de touche Escape */
#define F1      315                                     /* Code de touche F1 */
#define F2      316                                     /* Code de touche F2 */
#define F3      317                                     /* Code de touche F3 */
#define F4      318                                     /* Code de touche F4 */
#define F5      319                                     /* Code de touche F5 */
#define F6      320                                     /* Code de touche F6 */
#define F7      321                                     /* Code de touche F7 */
#define F8      322                                     /* Code de touche F8 */
#define F9      323                                     /* Code de touche F9 */
#define F10     324                                    /* Code de touche F10 */
#define HOME    327                                   /* Code de touche Home */
#define UP      328                                 /* Codes de curseur haut */
#define PgUp    329                                /* Code de touche page up */
#define END     335                                    /* Code de touche Fin */
#define DOWN    336                                  /* Codes de curseur bas */
#define PgDn    337                              /* Code de touche page down */
#define SF1     340                               /* Code de touche Shift+F1 */
#define SF2     341                               /* Code de touche Shift+F2 */
#define SF3     342                               /* Code de touche Shift+F3 */
#define SF4     343                               /* Code de touche Shift+F4 */
#define SF5     344                               /* Code de touche Shift+F5 */
#define SF6     345                               /* Code de touche Shift+F6 */
#define SF7     346                               /* Code de touche Shift+F7 */
#define SF8     347                               /* Code de touche Shift+F8 */
#define SF9     348                               /* Code de touche Shift+F9 */
#define SF10    349                              /* Code de touche Shift+F10 */


#define NB_LINES  13                             /* nombre de lignes de dump */
#define NB_BYTES   8                            /* nombre d'octets par ligne */

#define CRT_START ((unsigned far *) MK_FP(0x40, 0x4E))     /* ptrs Ram Video */
#define ADDR_6845 ((unsigned far *) MK_FP(0x40, 0x63))

struct velb               /* structure dans mem vido d'un caractre affich */
         {
          unsigned char caract;                                /* code ASCII */
          unsigned char attr;                         /* attribut de couleur */
         };
typedef struct velb far * VP;

typedef struct                              /* redfinition de pointeur long */
         {
          unsigned int seg;
          unsigned int off;
         } FULLPTR;
                                       /* prototypes des fonctions utilises */
unsigned int GetKey(void);
int  chk_addr(char *string, FULLPTR *addr);
void incptr(FULLPTR *currptr, unsigned decalage);
void decptr(FULLPTR *currptr, unsigned decalage);
int   search(char *string, FULLPTR *addr);
void disp_help(void);
void msg_box(char *message);

FULLPTR last_fnd;                  /* addresse de la derniere chaine trouve */
int auto_SF10=0;           /* flag d'autorisation de l'appui sur "Shift F10" */

                                                   /* Texte de la 1ere ligne */
char *titre     = "VMEM95              Address = 0000:0000";
                                                 /* texte des lignes de menu */
char *helpline0 = "   s+100    s+1    o+100    o+1    find";
char *helpline  = "s+1000  s+10  o+1000    o+10   addr    ";



/*****************************************************************************/
/*                            Module Principal                               */
/*****************************************************************************/
void main(int argc, char *argv[])
  {
   int fin=0;                                    /* flag de fin du programme */
   FULLPTR curr_addr={0, 0};        /* pointeur sur le premier octet affich */
   char s_newaddr[20];       /* tampon alpha d'entre d'une nouvelle adresse */
   int sens;    /* sens (incrmentation/dcrmentation) d'action des touches */
   VP d_vptr;                                           /* adresse RAM Video */
   VP dl_vptr;                /* pointeurs sur adresse vido 1ere ligne dump */
   unsigned seg_vptr, off_vptr;      /* dcomposition pointeur adresse vido */
   int key;                                                /* code de touche */
   int ret;                                    /* code de retour de fonction */
   int errflag=0;                                           /* flag d'erreur */

   if(argc > 2)                        /* si 2 parametre (ou plus) -> erreur */
     errflag=1;

   if((!errflag) && (argc == 2))                           /* si 1 parametre */
      errflag=chk_addr(argv[1], &curr_addr);           /* controle du format */

   if(errflag == 1)                                             /* si erreur */
     {
      fprintf(stderr, "usage : vmem95 [segment][:offset]\n");
      exit(-1);
     }
                /* acquisition adresse RAM Vido (pour tous types de cartes) */
   d_vptr= (VP) MK_FP((*ADDR_6845 == 0x3B4) ? 0xB000 : 0xB800, 0);
                                    /* calcul adresse vido de la 2eme ligne */
   dl_vptr = (VP) ((unsigned char far *) d_vptr + *CRT_START) + 80;
   seg_vptr=FP_SEG((void far *) dl_vptr);    /* sparation en segment/offset */
   off_vptr=FP_OFF((void far *) dl_vptr);

   window(1, 1, 40, 16);   /* aff. 1ere ligne en gris clair (noir sur le 95) */
   textbackground(LIGHTGRAY);
   clrscr();

   window(1, 2, 40, 14);         /* aff. zone Dump en noir (blanc sur le 95) */
   textbackground(BLACK);
   textcolor(LIGHTGRAY);
   clrscr();

   window(1, 1, 40, 16);
   textbackground(LIGHTGRAY);  /* sel. couleur texte menu (blanc/noir sur 95)*/
   textcolor(BLACK);
   gotoxy(1, 1);
   cputs(titre);                               /* affichage 1ere ligne cran */
   gotoxy(1, 15);
   cputs(helpline0);                            /* affichage 1ere ligne menu */
   disp_help();                         /* affichage de la 2eme ligne d'aide */

   do
     {
      gotoxy(31, 1);                  /* affichage adresse 1er octet affich */
      cprintf("%04X:%04X",  curr_addr.seg, curr_addr.off);

      do                                                /* affichage du dump */
        {
         asm     push    es          /* sauvegarde  des registres de segment */
         asm     push    di
         asm     push    ds
         asm     push    si

         asm     mov     ax,curr_addr.seg    /* initialisation des pointeurs */
         asm     mov     bx,curr_addr.off
         asm     mov     cx,seg_vptr
         asm     mov     dx,off_vptr

         asm     mov     es,ax                  /* segment:offset dans es:di */
         asm     mov     di,bx
         asm     mov     ds,cx                            /* vptr dans ds:si */
         asm     mov     si,dx

         asm     mov     dh,NB_LINES
             next_line :
         asm     push    es                     /* sauvegarde segment:offset */
         asm     push    di
                                           /* affichage adresse sur 5 digits */
         asm     mov     bx,di                /* calcul adresse sur 5 digits */
         asm     mov     cl,4
         asm     shr     bx,cl
         asm     mov     ax,es
         asm     add     bx,ax
         asm     mov     ch,bh           /* affichage des 2 premiers nibbles */
         asm     call    dsp_hexbyte
         asm     mov     ch,bl           /* affichage des 2 nibbles suivants */
         asm     call    dsp_hexbyte
         asm     mov     bx,di           /* affichage nibble de poids faible */
         asm     mov     ch,bl
         asm     call    dsp_digit
         asm     add     si,4                       /* on passe deux espaces */

         asm     mov     dl,NB_BYTES
             next_hex :              /* affichage des octets sous forme hexa */
         asm     mov     ch,es:[di]                    /* lecture de l'octet */
         asm     call    dsp_hexbyte                            /* affichage */
         asm     inc     si                            /* on passe un espace */
         asm     inc     si
         asm     inc     di                         /* incrmentation offset */
         asm     jnz     no_inc_seg0
         asm     mov     ax,es                 /* si offset = 0, maj segment */
         asm     add     ax,1000h
         asm     mov     es,ax
             no_inc_seg0 :
         asm     dec     dl
         asm     jnz     next_hex /* boucle tant que dernier caract non aff. */

         asm     inc     si                            /* on passe un espace */
         asm     inc     si

         asm     pop di           /* rinit segment:offset en dbut de ligne */
         asm     pop es
         asm     mov     dl,NB_BYTES
             next_char :            /* affichage des octets sous forme ASCII */
         asm     mov     ch,es:[di]                    /* lecture de l'octet */
         asm     mov     ds:[si],ch             /* criture en mmoire vido */
         asm     inc     si           /* on passe a l'adresse vido suivante */
         asm     inc     si
         asm     inc     di                         /* incrmentation offset */
         asm     jnz     no_inc_seg1
         asm     mov     ax,es                 /* si offset = 0, maj segment */
         asm     add     ax,1000h
         asm     mov     es,ax
             no_inc_seg1 :
         asm     dec     dl
         asm     jnz     next_char  /*boucle tant que dernier caract non aff.*/

         asm     add     si,80               /* on passe  la ligne suivante */

         asm     dec     dh
         asm     jnz     next_line  /*boucle tant que derniere ligne pas aff.*/

         asm     pop     si          /* rcup valeurs init de es:di et ds:si */
         asm     pop     ds
         asm     pop     di
         asm     pop     es

         asm     jmp     SHORT  end_display  /* on saute les sous programmes */

                                                          /* SOUS PROGRAMMES */
         asm dsp_hexbyte :           /* affichage d'un octet sous forme hexa */
         asm     mov     ah,ch              /* entre : CH = code  afficher */
         asm     mov     cl,4               /* dcalage nibble de poids fort */
         asm     shr     ch,cl
         asm     call    dsp_digit            /* affichage nibble poids fort */
         asm     mov     ch,ah                    /* rcupration de l'octet */
         asm     call    dsp_digit      /* pour affichage octet poids faible */
         asm     ret

         asm dsp_digit :                     /* affichage d'un digit en hexa */
                                          /* entre : CH = nibble  afficher */
         asm     and     ch,0Fh             /* on ne garde que le 1er nibble */
         asm     cmp     ch,9                         /* si ch superieur  9 */
         asm     ja      hex_digit                          /* c'est un hexa */
         asm     add     ch,'0'                    /* conversion en '0'..'9' */
         asm     jmp     SHORT display
             hex_digit :
         asm     add     ch,('A'-10)               /* conversion en 'A'..'F' */
             display :
         asm     mov     ds:[si],ch             /* ecriture en mmoire vido */
         asm     inc     si                /* dcalage ptr sur mmoire vido */
         asm     inc     si
         asm     ret

            end_display :
            ;
        }
      while(!kbhit());                /* tant qu'aucune touche n'est presse */
                          /* (c'est ce qui permet l'affichage en temps rel) */

      key=GetKey();                      /* acquisition du code de la touche */

      sens = 1;
      switch(key)                            /* suivant le code de la touche */
        {
                                        /* dcalage d'une ligne vers le haut */
         case DOWN  : incptr(&curr_addr, NB_BYTES);
                      break;

                                         /* dcalage d'une ligne vers le bas */
         case UP    : decptr(&curr_addr, NB_BYTES);
                      break;
                                                            /* page suivante */
         case PgDn  : incptr(&curr_addr, NB_BYTES*NB_LINES);
                      break;
                                                          /* page prcdente */
         case PgUp  : decptr(&curr_addr, NB_BYTES*NB_LINES);
                      break;

                                            /* affichage dbut de la mmoire */
         case HOME  : curr_addr.seg = 0;
                      curr_addr.off = 0;
                      break;

                                              /* affichage fin de la mmoire */
         case END   : curr_addr.seg = 0;
                      curr_addr.off = 0;
                      decptr(&curr_addr, NB_BYTES*NB_LINES);
                      break;

                     /* incrmentations/dcrmentations des offsets/segments */
         case SF1   : sens = -1;
         case F1    : curr_addr.seg += 0x1000*sens;
                      break;

         case SF2   : sens = -1;
         case F2    : curr_addr.seg += 0x0100*sens;
                      break;

         case SF3   : sens = -1;
         case F3    : curr_addr.seg += 0x0010*sens;
                      break;

         case SF4   : sens = -1;
         case F4    : curr_addr.seg += 0x0001*sens;
                      break;

         case SF5   : sens = -1;
         case F5    : curr_addr.off += 0x1000*sens;
                      break;

         case SF6   : sens = -1;
         case F6    : curr_addr.off += 0x0100*sens;
                      break;

         case SF7   : sens = -1;
         case F7    : curr_addr.off += 0x0010*sens;
                      break;

         case SF8   : sens = -1;
         case F8    : curr_addr.off += 0x0001*sens;
                      break;

                                         /* slection d'une nouvelle adresse */
         case F9    : auto_SF10=0;        /* Shift F10 n'est plus autorise */
                      gotoxy(14, 1);
                      cputs("   New Address =           ");
                      gotoxy(31, 1);
                      s_newaddr[0]=10;       /* nombre de caractres maxi+1 */
                      cgets(s_newaddr);        /* lecture chaine au clavier */
                                         /* controle du format de la chaine */
                      ret=chk_addr(s_newaddr+2, &curr_addr);
                      if(ret != 0)                             /* si erreur */
                        {
                         msg_box("Invalid Address Format");
                         gotoxy(1, 16);
                         cputs(helpline);       /* raffichage ligne d'aide */
                        }
                      gotoxy(1, 1);               /* raffichage 1ere ligne */
                      cputs(titre);
                      break;

         case F10   : gotoxy(14, 1);
                      cputs("String Search :            ");
                      s_newaddr[0]=11;       /* nombre de caractres maxi+1 */
                      gotoxy(30, 1);
                      cgets(s_newaddr);               /* acquisition chaine */
                      last_fnd.seg = last_fnd.off = 0;      /* dpart  0:0 */
                      search(s_newaddr+2, &curr_addr);           /* cherche */
                      gotoxy(1, 1);                 /* raffichage du titre */
                      cputs(titre);
                      break;

         case SF10  : if(auto_SF10)                /* si Shift F10 autoris */
                        {                        /* on relance la recherche */
                         search(s_newaddr+2, &curr_addr);
                        }
                      break;

         case ESC   : fin=1;                            /* fin du programme */
                      break;
        }
     }
   while(!fin);

   textbackground(BLACK);                           /* effacement de l'cran */
   textcolor(LIGHTGRAY);
   clrscr();
   printf("VMEM95 Version 2.00\n");
  }


/*****************************************************************************/
/* GETKEY: lecture d'un caractre au clavier                                 */
/* Entre  : Aucune                                                          */
/* Sortie  : Code de touche reue         < 256 : touche normale             */
/*                                       >= 256 : touche tendue             */
/*****************************************************************************/
unsigned int GetKey(void)
   {
    union REGS Register;  /* Variable de registres pour appel d'interruption */

    do
      {
       Register.h.ah = 2;       /* Numro de fonction pour Lire tat clavier */
       int86(0x16, &Register, &Register);    /* Appeler int. clavier du BIOS */
      }
    while(!bioskey(1));               /* Rpter jusqu' ce que touche prte */
    Register.h.ah = 0;                    /* N de fonction pour Lire touche */
    int86(0x16, &Register, &Register);  /* Appeler interruption clavier BIOS */
    return((Register.h.al) ? Register.h.al : Register.h.ah | 256);
   }


/*****************************************************************************/
/* CHK_ADDR : Vrification d'une chaine au format "segment:offset"           */
/*            Formats admis : "segment" ou ":offset" ou "segment:offset"     */
/*            avec "segment" et "offset" compris entre 0000 et FFFF          */
/* Entres :  string = chaine a tester                                       */
/* Sorties :  addr = adresse correspondant au contenu de  la chaine. Si le   */
/*                 segment ou l'offset n'est pas spcifi, la variable       */
/*                 correspondante n'est pas modifie                         */
/* valeur retourne : 1 si erreur de format, 0 sinon.                        */
/*****************************************************************************/
int chk_addr(char *string, FULLPTR *addr)
   {
    unsigned int sg;                /* offset et segment convertis en entier */
    unsigned int of;
    char s_seg[10];                                   /* chaines temporaires */
    char s_off[10];
    int dp_found = 0;                /* flag indiquant que le ':' est trouv */
    int pres_seg=0;                         /* flag de prsence d'un segment */
    int pres_off=0;                          /* flag de prsence d'un offset */
    int i1, i2;                                   /* indices sur les chaines */
    int errflag = 0;                                        /* flag d'erreur */

    strupr(string);                       /* conversion chaine en majuscules */

    memset(s_seg, 0, 10);                 /* initialisation de la chaine  0 */
    memset(s_off, 0, 10);

    i2=0;
    for(i1=0; i1<strlen(string); i1++)  /* pour tous les caract. de "string" */
      {
       if(string[i1]==':')                                  /* si ':' trouv */
         {
          dp_found = 1;
          i2=0;
         }
       else                                                         /* sinon */
         {
          if(dp_found)                                /* si ':' a t trouv */
            {
             pres_off=1;   /* le caract. dans "string" appartient  l'offset */
             s_off[i2++]=string[i1];
            }
          else                                                      /* sinon */
            {
             pres_seg=1;   /* le caract. dans "string" appartient au segment */
             s_seg[i2++]=string[i1];
            }
         }
      }
                       /* si les chaines ont une longueur sup.  4 caractre */
    if((strlen(s_seg) > 4) || (strlen(s_off) > 4))
       errflag = 1;                                                /* erreur */

    if(!errflag)                              /* si pas d'erreur prcdement */
      {
       if(pres_seg)                              /* si prsence d'un segment */
          if(sscanf(s_seg, "%x", &sg) != 1)           /* test si format Hexa */
             errflag = 1;
       if(pres_off)                               /* si prsence d'un offset */
          if(sscanf(s_off, "%x", &of) != 1)           /* test si format Hexa */
             errflag = 1;
      }

    if(!errflag)                              /* si pas d'erreur prcdement */
      {
       if(pres_seg)                           /* stockage du nouveau segment */
          addr->seg=sg;
       if(pres_off)                             /* stockage du nouvel offset */
          addr->off=of;
      }

    return(errflag);                              /* retour du flag d'erreur */
   }


/*****************************************************************************/
/* INCPTR : Incrmentation d'un pointeur, tenant compte des limites de       */
/*            segment.                                                       */
/* Entres :  addr = adresse du pointeur                                     */
/*            dcalage = dcalage  appliquer                                */
/* valeur retourne : aucune                                                 */
/*****************************************************************************/
void incptr(FULLPTR *addr, unsigned decalage)
   {
    int old_offset;                                         /* ancien offset */

    old_offset = addr->off;                 /* sauvegarde de l'ancien offset */
    addr->off += decalage;                                       /* dcalage */
    if(addr->off < old_offset)          /* si dpassement de limite d'offset */
       addr->seg += 0x1000;                        /* mise  jour du segment */
   }


/*****************************************************************************/
/* DECPTR : Dcrmentation d'un pointeur, tenant compte des limites de       */
/*            segment.                                                       */
/* Entres :  addr = adresse du pointeur                                     */
/*            dcalage = dcalage  appliquer                                */
/* valeur retourne : aucune                                                 */
/*****************************************************************************/
void decptr(FULLPTR *addr, unsigned decalage)
   {
    int old_offset;                                         /* ancien offset */

    old_offset = addr->off;                 /* sauvegarde de l'ancien offset */
    addr->off -= decalage;                                       /* dcalage */
    if(addr->off > old_offset)          /* si dpassement de limite d'offset */
       addr->seg -= 0x1000;                        /* mise  jour du segment */
   }


/*****************************************************************************/
/* SEARCH : Recherche d'une chaine en mmoire.                               */
/* Entres :  string = chaine a trouver                                      */
/* Sorties :  addr = adresse du premier caractre de la chaine, si trouve.  */
/*                   sinon, pas de changement                                */
/* met  jour : last_fnd = adresse de la derniere chaine trouve, qui sera   */
/*                         le nouveau dpart si Shift F10                    */
/* valeur retourne : 1 si chaine trouve,   0 sinon.                        */
/*****************************************************************************/
int search(char *string, FULLPTR *addr)
   {
    int  found;                  /* flag indiquant que la chaine est trouve */
    unsigned seg_str, off_str;              /* segment et offset de "string" */

    strupr(string);                     /* conversion "string" en majuscules */

    seg_str = FP_SEG((char far *) string); /* decomposition adr. de "string" */
    off_str = FP_OFF((char far *) string);

    gotoxy(1, 16);                                   /* affichage du message */
    cputs(" Searching...                         ");


    asm     push    es               /* sauvegarde  des registres de segment */
    asm     push    di
    asm     push    ds
    asm     push    si

    asm     mov     ax,last_fnd.seg          /* initialisation des pointeurs */
    asm     mov     bx,last_fnd.off
    asm     mov     cx,seg_str
    asm     mov     dx,off_str

    asm     mov     es,ax                                /* 'sch' dans es:di */
    asm     mov     di,bx
    asm     mov     ds,cx                               /* string dans ds:si */
    asm     mov     si,dx

    asm     inc     di                       /* incrmentation adresse 'sch' */
    asm     jnz     no_inc_seg0
    asm     mov     ax,es                       /* si offset=0, incr segment */
    asm     add     ax,1000h
    asm     mov     es,ax
        no_inc_seg0 :
    asm     mov     ch,ds:[si]               /* lecture du premier caractre */
    asm     mov     dx,0                         /* initialisation found  0 */

        loopgen :                             /* boucle sur toute la mmoire */
    asm     mov     bl,es:[di]                     /* lecture *'sch' dans bl */

    asm     cmp     bl,'a'                              /* conversion en upr */
    asm     jb      suite0
    asm     cmp     bl,'z'
    asm     ja      suite0
    asm     sub     bl,20h
        suite0 :
    asm     cmp     bl,ch          /* comparaison 1er octet des deux chaines */
    asm     jne     next_addr       /* si non gaux, on reprend la recherche */
    asm     push    es             /* sauvegarde adresse courante sch et str */
    asm     push    di
    asm     push    ds
    asm     push    si
        loop_cmp :                           /* comparaison des deux chaines */
    asm     inc     si                         /* incrmentation adresse str */
    asm     jnz     no_inc_seg1
    asm     mov     ax,ds                       /* si offset=0, incr segment */
    asm     add     ax,1000h
    asm     mov     ds,ax
        no_inc_seg1 :
    asm     mov     bh,ds:[si]              /* lecture caract de str dans bh */
    asm     cmp     bh,0         /* si fin de str, les 2 chaines sont egales */
    asm     je      founded
    asm     inc     di                       /* incrmentation adresse 'sch' */
    asm     jnz     no_inc_seg2
    asm     mov     ax,es                       /* si offset=0, incr segment */
    asm     add     ax,1000h
    asm     mov     es,ax
        no_inc_seg2 :
    asm     mov     bl,es:[di]            /* lecture caract de 'sch' dans bl */
    asm     cmp     bl,'a'                              /* conversion en upr */
    asm     jb      suite1
    asm     cmp     bl,'z'
    asm     ja      suite1
    asm     sub     bl,20h
        suite1 :
    asm     cmp     bh,bl                 /* comparaison des deux caractres */
    asm     jne     not_founded    /* si non egaux, on continue la recherche */
    asm     jmp     SHORT loop_cmp     /*si gaux, on regarde caract suivants*/

        founded :                                       /* si chaine trouve */
    asm     mov     dx,1                              /* armement flag found */
        not_founded :
    asm     pop     si         /* rcupration adresses str et sch courantes */
    asm     pop     ds
    asm     pop     di
    asm     pop     es
        next_addr :                  /* poursuite de la recherche dans 'sch' */
    asm     cmp     dx,1                            /* fin si chaine trouve */
    asm     je      fin
    asm     inc     di                       /* incrmentation adresse 'sch' */
    asm     jnz     loopgen                /* suite recherche si offset != 0 */
    asm     mov     ax,es                       /* si offset=0, incr segment */
    asm     add     ax,1000h
    asm     mov     es,ax
    asm     cmp     ax,0000           /* es:di != 0000:0000, suite recherche */
    asm     jne     SHORT loopgen
        fin :
    asm     mov     ax,es         /* rcupration valeurs seg_sch et off_sch */
    asm     mov     bx,di
    asm     pop     si      /* rcupration anciennes valeurs es:di et ds:si */
    asm     pop     ds
    asm     pop     di
    asm     pop     es
    asm     mov     last_fnd.seg,ax       /* initialisation last_fnd = 'sch' */
    asm     mov     last_fnd.off,bx
    asm     mov     found,dx                 /* rcupration valeur de found */

    if(found)                                           /* si chaine trouve */
      {
       auto_SF10=1;                   /* autorisation de l'accs  Shift F10 */
       addr->seg = last_fnd.seg;            /* stockage de l'adresse trouves */
       addr->off = last_fnd.off;
       gotoxy(1, 16);                                /* affichage du message */
       cputs(" Shift-F10 to continue the Search     ");
      }
    else                                            /* si chaine non trouve */
      {
       auto_SF10 = 0;           /* la touche Shift F10 n'est plus accessible */
       msg_box("    String not found");              /* affichage du message */
       disp_help();                      /* affichage derniere ligne du menu */
      }
    return(found);                             /* retour 1 si chaine trouve */
   }


/*****************************************************************************/
/* DISP_HELP : affichage par dfaut de la derniere ligne de menu             */
/* Entres :  aucune                                                         */
/* valeur retourne : aucune                                                 */
/*****************************************************************************/
void disp_help(void)
   {
    gotoxy(1, 16);
    cputs(helpline);
   }


/*****************************************************************************/
/* MSG_BOX : Affichage d'une fentre de message, avec attente de pression    */
/*           de touche.                                                      */
/* Entres : message = chaine contenant le texte du message (22 caract. maxi)*/
/* valeur retourne : aucune                                                 */
/*****************************************************************************/
void msg_box(char *message)
   {
    char under_box[2*24*2];

    gettext(9, 7, 32, 8, under_box); /* sauvegarde de la zone sous la fentre*/
    window(9, 7, 32, 8);            /* visualisation fentre, noir/blanc (95)*/
    textbackground(LIGHTGRAY);
    textcolor(BLACK);
    clrscr();
    gotoxy(2, 1);                              /* affichage lignes de textes */
    cputs(message);
    gotoxy(7, 2);
    cputs("Press any Key");
    GetKey();                               /* attente de pression de touche */
    window(1, 1, 40, 16);
    puttext(9, 7, 32, 8, under_box);    /* restauration zone sous la fentre */
   }