;*****************************************************************************;
;*****************************************************************************;
;**                           WHEREIS.ASM                                   **;
;**                 Recherche de fichiers sur le disque                     **;
;**                                                                         **;
;**   Dernire modification : 30/06/93        Auteur : Jacques Belin        **;
;**       Cration                                                          **;
;**                                                                         **;
;*****************************************************************************;
;*****************************************************************************;
         DOSSEG
code     segment para 'CODE'
         assume cs:code,ds:code
         ORG    100h
start:   jmp    main                    ; premire inst. excute

PATH_SIZ EQU    80                      ; taille maxi d'un chemin
DTA_SIZE EQU    48                      ; taille de la DTA

FA_RDNLY EQU    1                       ; codes d'attributs des fichiers
FA_HIDD  EQU    2
FA_SYST  EQU    4
FA_VOL   EQU    8
FA_DIR   EQU    16
FA_ARCH  EQU    32

         INCLUDE getopt.inc             ; routine d'analyse des options
                                        ; (sources parus dans JPC 87)

optstr   DB     "d:hsra",0              ; chaine des options
errflg   DB     0                       ; flag d'erreur
opti     DW     0                       ; sauvegarde de optind
nb_files DW     0                       ; nombre de fichiers trouvs
path_ini DB     PATH_SIZ dup (0)        ; directory initial
attr     DB     0                       ; attributs spcifis en option
nodir    DB     0                       ; flag indiquant un paramtre "*.*"
found    DB     0                       ; flag indiquant si dir courant affich

                                        ; Message d'erreur
usage    DB     "usage :  whereis [-h] [-s] [-r] [-a] [-d path] [file...]"
         DB     13,10,10,"$"

dirname  DB     13,10,"Directory : "    ; affichage du directory courant
cur_path DB     PATH_SIZ dup (?)
cr       DB     13,10,0

total    DB     13,10,"  "              ; affichage du nombre de fichiers
total_2  DB     "xxxxxx files found",13,10,"$"

no_path  DB     ".",0                   ; chaines diverses
back_sl  DB     "\",0
wilds    DB     "\"
wilds2   DB     "*.*",0


main:    mov    bx,cs
         mov    ds,bx                  ; on assure DS=CS
         mov    es,bx                  ; on assure ES=CS

         mov    ah,4Ah                 ; on rjuste taille du bloc programmee
         mov    bx,4096/16
         int    21h
         mov    sp,4096                ; on replace le pointeur de pile

         mov    ax,3800h               ; rcupration du code de pays
         mov    dx,OFFSET path_ini     ; (pour d_entry)
         int    21h
         mov    bx,dx
         mov    ax,[bx]
         mov    [country],al
         mov    byte ptr [bx],0        ; rinitialisation path_ini  0

         call   parse                  ; parsing dans argv[]

optloop: call   getopt                 ; analyse des options
         cmp    al,EOF                 ; fin d'analyse ?
         je     main_1                 ; oui, on passe  la suite du prgm
opth:    cmp    al,"h"                 ; si option "h"
         jne    opts
         or     byte ptr [attr],FA_HIDD ;on arme le bit correspondant dans attr
         jmp    nextopt                ; ..et on continue l'analyse
opts:    cmp    al,"s"                 ; idem pour l'option "s"...
         jne    optr
         or     byte ptr [attr],FA_SYST
         jmp    nextopt
optr:    cmp    al,"r"                 ; idem pour l'option "r"...
         jne    opta
         or     byte ptr [attr],FA_RDNLY
         jmp    nextopt
opta:    cmp    al,"a"                 ; idem pour l'option "a"...
         jne    optd
         or     byte ptr [attr],FA_ARCH
         jmp    nextopt
optd:    cmp    al,"d"                 ; Si option "d"
         jne    opterr
         mov    di,[optarg]            ; copie de ce qui est point par
         mov    si,OFFSET path_ini     ;  optarg dans path_ini
         call   strcpy
         jmp    nextopt
opterr:  cmp    al,"?"                 ; si erreur, on arme le flag
         jne    nextopt
         inc    byte ptr [errflg]
nextopt: jmp    optloop                ; on boucle tant qu'on a pas EOF
         ;-------------

main_1:  cmp    byte ptr [errflg],0    ; si une erreur a t dtecte...
         je     main_2
         mov    dx,OFFSET usage        ; ...on affiche le message d'erreur...
         mov    ah,09h
         int    21h
         jmp    exit                   ; ...et on sort.
         ;----------

main_2:  mov    ax,[optind]            ; argc == optind ? (pas de path ?)
         cmp    ax,[argc]
         je     main_3                 ; non
         mov    [opti],ax

main_3:  mov    dx,OFFSET path_ini
         call   strlen
         cmp    cx,0
         je     main_4
         mov    bx,cx
         cmp    byte ptr [si+bx-1],"\" ; dernier caractre de path_ini="\" ?
         jne    main_4                 ; non, on continue
         mov    byte ptr [si+bx-1],0   ; oui, on l'efface

main_4:  push   ds                     ; on fait pointer ES:DI sur path_ini
         pop    es
         mov    di,dx
         call   whereis                ; APPEL A LA ROUTINE PRINCIPALE

         mov    ax,[nb_files]          ; AFFICHAGE DU NOMBRE DE FICHIERS
         xor    dx,dx
         mov    si,OFFSET total_2      ; conversion du nombre en chaine
         mov    bx,6
         call   ltoa
         mov    dx,OFFSET total        ; affichage de la chane
         mov    ah,09h
         int    21h

exit:    mov    ah,4ch                 ; retour au DOS
         int    21h


;****************************************************
; WHEREIS : cherche un (ou plusieurs) fichiers dans
;           l'arborescence
; entres : ES:DI adresse du nom du directory courant
;           (termin par caractre 0)
;****************************************************
whereis  PROC   NEAR
         push   ax
         push   bx
         push   cx
         push   dx
         push   bp
         push   es
         push   di
         push   ds
         push   si

         call   getdta                 ; sauvegarde de la DTA dans la pile
         push   ax

         mov    ah,48h
         mov    bx,((DTA_SIZE+PATH_SIZ)/16)+1 ; taille en paragraphes
         int    21h                    ; allocation d'un bloc de mmoire
         push   ax

         push   di                     ; sauvegarde paramtre d'entre
         push   es
         mov    bp,sp                  ; on va se servir de BP comme indice
                                       ; pour les accs dans la pile

         ; partir d'ici on a dans la pile :
         ; bp    =  ES niveau prcdent
         ; bp+2  =  DI niveau prcdent
         ; BP+4  =  segment du buffer courant
         ; BP+6  =  DTA prcdente
         ;   .
         ;   .

         xor    bx,bx                  ; fait pointer nouvelle DTA sur buffer
         call   setdta

         mov    ax,cs:[opti]           ; on repositionne optind sur 1er param
         mov    cs:[optind],ax
         mov    byte ptr cs:[found],0  ; on dsarme le flag 'found'

where_1: mov    ax,ss:[bp]             ; copie path courant aprs DTA ds buffer
         mov    es,ax
         mov    di,ss:[bp+2]
         mov    ax,ss:[bp+4]
         mov    ds,ax
         mov    si,DTA_SIZE
         call   strcpy

         push   cs                     ; on ajoute "\"  la fin
         pop    es
         mov    di,OFFSET back_sl
         call   strcat

         cmp    word ptr cs:[opti],0   ; y a t-il des paramtres ?
         jne    where_2                ; oui, on va plus bas

         mov    di,OFFSET wilds2       ; sinon, on ajoute "*.*"  la fin
         call   strcat
         jmp    where_3
         ;-------------
                                       ; on copie le param. point par optind
where_2: mov    ax,cs:[psp]
         mov    es,ax
         mov    bx,cs:[optind]         ; bx = optind
         shl    bx,1
         mov    di,OFFSET argv         ; si = argv
         mov    di,cs:[di+bx]          ; di ^ argv[optind]
         call   strcat

                                       ; RECHERCHE DES FICHIERS DU REPERTOIRE
where_3: mov    byte ptr cs:[nodir],0  ; on arme 'nodir' si param = "*.*"
         cmp    word ptr es:[di],".*"
         jne    where_4
         cmp    byte ptr es:[di+2],"*"
         jne    where_4
         mov    byte ptr cs:[nodir],1

where_4: mov    ah,4Eh                 ; cherche premier fichier du rpertoire
         mov    dx,si
         mov    cx,FA_DIR+FA_HIDD+FA_SYST
         int    21h
where_5: jc     where_a                ; si carry -> recherche termine

         mov    bl,ds:[15h]            ; bl = attribut (sans bit Volume)
         and    bl,111111b
         mov    al,cs:[attr]           ; attr = 0 (pas de recherche sur option) ?
         cmp    al,0
         jne    where_6                ; non, affichage suivant attr
         test   bl,FA_DIR              ; Si bit directory non arm
         jz     where_7                ; ..on affiche
         cmp    byte ptr cs:[nodir],1  ; on n'affiche pas si param "*.*"..
         je     where_9
         cmp    byte ptr ds:[1Eh],"."  ; ..ou si nom directory = "." ou ".."
         je     where_9
         jmp    where_7

where_6: test   al,bl                  ; si aucun bit de bl correspond  al
         jz     where_9                ;  ...on n'affiche pas
where_7: inc    word ptr cs:[nb_files] ; inc. nombre de fichiers traits
         cmp    byte ptr cs:[found],0
         jne    where_8
         mov    byte ptr cs:[found],1
         push   ds

         mov    ax,ss:[bp]             ; ES:DI = paramtre d'entre
         mov    es,ax
         mov    di,ss:[bp+2]
         push   cs
         pop    ds
         mov    si,OFFSET cur_path
         call   strcpy                 ; copie nom directory en fin de chaine
         push   cs                     ; on ajoute un CR  la fin
         pop    es
         mov    di,OFFSET cr
         call   strcat

         mov    bx,1                   ; affichage du texte dans 'stdout'
         mov    dx,OFFSET dirname
         call   fprintf
         pop    ds

where_8: xor    si,si
         call   d_entry                ; affichage de l'entre

where_9: mov    ah,4Fh                 ; cherche fichier suivant
         int    21h
         jmp    where_5                ; et on boucle
         ;-------------

where_a: cmp    word ptr cs:[opti],0   ; y a t-il des paramtres ?
         je     where_b                ; non, on va plus bas
         inc    word ptr cs:[optind]   ; sinon, on incrmente optind...
         mov    ax,cs:[optind]         ; et on boucle tant qu'il y a des params
         cmp    cs:[argc],ax
         je     where_b
         jmp    where_1

                                       ; RECHERCHE DANS LES SOUS REPERTOIRES
where_b: pop    es                     ; copie path courant aprs DTA ds buffer
         push   es
         mov    di,ss:[bp+2]
         mov    ax,ss:[bp+4]
         mov    ds,ax
         mov    si,DTA_SIZE
         call   strcpy

         push   cs                     ; on ajoute "\*.*"  la fin
         pop    es
         mov    di,OFFSET wilds
         call   strcat

         mov    dx,si
         mov    dx,DTA_SIZE            ; cherche premier fichier
         mov    ah,4Eh
         mov    cx,FA_DIR+FA_HIDD
         int    21h

where_c: jc     where_e                ; si carry -> termin
         mov    al,ds:[15h]            ; si attribut fichier # directory...
         and    al,FA_DIR
         jz     where_d
         cmp    byte ptr ds:[1Eh],"."  ; ... et nom directory = "." ou ".."
         je     where_d                ; ...on passe  l'entre suivante

         mov    ax,ss:[bp]             ; ES:DI = paramtre d'entre (rcursif)
         mov    es,ax
         mov    di,ss:[bp+2]
         mov    si,DTA_SIZE            ; copie paramtre dans buffer
         call   strcpy

         push   cs                     ; on ajoute "\" au paramtre
         pop    es
         mov    di,OFFSET back_sl
         call   strcat

         push   ds                     ; on ajoute le nom de l'entre
         pop    es
         mov    di,1Eh
         call   strcat

         mov    di,si                  ; ES:DI = nouveau paramtre
         call   whereis                ; appel rcursif

where_d: mov    ah,4Fh                 ; cherche fichier suivant
         int    21h
         jmp    where_c                ; et on boucle
         ;-------------

where_e: pop    ax                     ; on depile les donnes inutiles
         pop    ax

         pop    es                     ; libration du buffer
         mov    ah,49h
         int    21h

         pop    ax                     ; reinitialisation de l'ancienne DTA
         xor    bx,bx
         call   setdta

         pop    si
         pop    ds
         pop    di
         pop    es
         pop    bp
         pop    dx
         pop    cx
         pop    bx
         pop    ax
         ret
whereis  ENDP



;****************************************************
; D_ENTRY : affiche une entre de directory
; entres : DS:SI adresse de la DTA issue des fonctions
;           DOS 4E et 4F
; Note : il est conseill de mettre a jour (par le
;        programme princpal, avec la fonction Dos 38h)
;        la variable "country"
;****************************************************
country  DB     1                      ; format de date par dfaut : Europe
d_filnm  DB     " "
filename DB     "xxxxxxxx.xxx"
len_file DB     " xxxxxxx "
date     DB     "jj/mm/aa hh:mm "
attribs  DB     "HSRA",13,10,0
dir_ent  DB     "  <DIR>  "

d_entry  PROC   NEAR
         pushf
         push   ax
         push   bx
         push   cx
         push   dx
         push   es
         push   di
         push   ds
         push   si
         push   bp

         push   cs                     ; ES <- CS
         pop    es
         push   si
         mov    bp,sp

                                       ; COPIE DU NOM DU FICHIER
         mov    di,OFFSET filename
         add    si,1eh                 ; si pointe sur le premier caractre
                                       ;   du nom
         mov    cx,13
         cld
d_ent_1: movsb
         dec    cx
         cmp    byte ptr ds:[si],0     ; fin de chaine ?
         jne    d_ent_1
d_ent_2: mov    byte ptr es:[di]," "   ; on complete avec des blancs
         inc    di
         loop   d_ent_2


         mov    si,ss:[bp]             ; AFFICHAGE LONGUEUR
         mov    di,OFFSET len_file
         mov    al,[si+15h]            ; lecture attribut
         test   al,FA_DIR              ; Est-ce une entre directory ?
         jz     d_ent_3                ; non, on va plus bas
         mov    cx,8                   ; sinon, copie de <DIR>  la place
         mov    si,OFFSET dir_ent      ;  de la longueur
         push   ds
         push   cs
         pop    ds
         rep    movsb
         pop    ds
         jmp    d_ent_4
d_ent_3: mov    si,ss:[bp]             ; conversion longueur en chaine
         mov    ax,ds:[si+1Ah]
         mov    dx,ds:[si+1Ch]
         mov    bx,8
         push   ds
         push   es
         pop    ds
         mov    si,di
         call   ltoa
         pop    ds
                                       ; AFFICHAGE DATE
d_ent_4: pop    si
         mov    di,OFFSET date
         mov    dx,[si+18h]            ; DTA.date -> dx
         mov    ax,dx                  ; numro du jour dans ax
         and    ax,11111b
         mov    cl,5                   ; numro du mois dans bx
         shr    dx,cl
         mov    bx,dx
         and    bx,1111b
         cmp    byte ptr cs:[country],1 ; format de date Europe ?
         je     d_ent_5                ; oui, on va plus bas
         xchg   ax,bx                  ; sinon, on inverse mois et jour
d_ent_5: call   d_ent_a                ; affichage "XX/../.."
         mov    ax,bx                  ; affichage "../XX/.."
         call   d_ent_a
         mov    cl,4                   ; affichage anne
         shr    dx,cl
         mov    ax,dx
         add    ax,80
         call   d_ent_a

                                       ; AFFICHAGE HEURE
         mov    dx,[si+16h]            ; DTA.heure -> dx
         mov    cl,5                   ; on ne s'occupe pas des secondes
         shr    dx,cl
         mov    bx,dx                  ; nombre de minutes dans bx
         and    bx,111111b
         mov    cl,6                   ; nombre d'heures dans ax
         shr    dx,cl
         mov    ax,dx
         call   d_ent_a                ; affichage des heures
         mov    ax,bx
         call   d_ent_a                ; affichage des minutes

                                       ; AFFICHAGE DES ATTRIBUTS
         mov    al,[si+15h]            ; lecture attribut
         push   cs
         pop    ds
         mov    word ptr [di],".."     ; on initialise zone attributs  "...."
         mov    word ptr [di+2],".."
         test   al,FA_HIDD             ; si attribut "cach" arm..
         jz     d_ent_6
         mov    byte ptr [di],"H"      ; on remplace le point par "H"
d_ent_6: test   al,FA_SYST             ; idem pour attribut "systme"
         jz     d_ent_7
         mov    byte ptr [di+1],"S"
d_ent_7: test   al,FA_RDNLY            ; idem pour attribut "read only"
         jz     d_ent_8
         mov    byte ptr [di+2],"R"
d_ent_8: test   al,FA_ARCH             ; idem pour attribut "archive"
         jz     d_ent_9
         mov    byte ptr [di+3],"A"

d_ent_9: mov    dx,OFFSET d_filnm      ; ...et on affiche la chane !
         mov    bx,1
         call   fprintf

         pop    bp
         pop    si
         pop    ds
         pop    di
         pop    es
         pop    dx
         pop    cx
         pop    bx
         pop    ax
         popf
         ret
                                       ; CONVERSION EN CHAINE ET DECALAGE
d_ent_a: aam                           ; conversion en BCD
         add    ax,3030h               ; conversion en caractres
         xchg   ah,al                  ; on inverse les digits
         mov    cs:[di],ax             ; criture en mmoire
         add    di,3                   ; on dplace le pointeur sur suivants
         ret
d_entry  ENDP


;****************************************************
; STRCAT  : place une chaine  la fin d'une autre
; entres : ES:DI  adresse de la chaine source
;           (termine par caractre 0)
;           DS:SI  adresse de la chaine destination
;****************************************************
strcat   PROC   NEAR
         push   cx
         push   dx
         push   si

         mov    dx,si                  ; calcul longueur de chaine
         call   strlen
         add    si,cx                  ; on copie aprs le dernier caractre
         call   strcpy

strca_1: pop    si
         pop    dx
         pop    cx
         ret
strcat   ENDP


;****************************************************
; GETDTA  : Donne l'adresse de la DTA
; entres : Aucune
; sortie  : AX:BX = segment DTA
;****************************************************
getdta   PROC   NEAR
         push   es

         mov    ah,2Fh                 ;  lecture adresse DTA
         int    21h
         mov    ax,es

         pop    es
         ret
getdta   ENDP


;****************************************************
; SETDTA  : Positionne l'adresse de la DTA
; entres : AX:BX = adresse DTA
; sortie  : aucune
;****************************************************
setdta   PROC   NEAR
         push   ax
         push   bx
         push   dx
         push   ds

         mov    ds,ax                  ; on positionn les paramtres
         mov    dx,bx
         mov    ah,1Ah                 ; selection de la DTA
         int    21h

         pop    ds
         pop    dx
         pop    bx
         pop    ax
         ret
setdta   ENDP

;****************************************************
; FPRINTF : affiche une chaine de caractres dans
;           le flux BX
; entres : DS:DX = Chaine
;           BX = handle
; sortie  : Aucune
;****************************************************
fprintf  PROC   NEAR
         push   ax
         push   cx
         call   strlen                 ; calcul de la longueur de la chaine
         mov    ah,40h                 ; affichage
         int    21h
         pop    cx
         pop    ax
         ret
fprintf  ENDP

;================================================
; LTOA : Conversion d'un entier long en chaine
;        justifie  droite
;        Pas de code de fin de chaine ('\0')
; Entres: DX:AX = nombre  convertir
;          BX = nombre de digits total
;          DS:SI = Adresse du dbut de chaine
;================================================
ltoa     PROC    NEAR
         push    bx
         push    cx
         push    di
         push    si
         push    bp

         push    dx                    ; on sauve le paramtre dans la pile
         push    ax                    ;  (pour simplifier les accs)
         mov     bp,sp

         add     si,bx                 ; calcul position du dernier caractre
         dec     si                    ;  de la chaine (digit poids faible)

         mov     cx,10                 ; diviseur (base)

ltoa_1:  mov     ax,[bp+2]             ; on rcupre le mot de poids fort
         sub     dx,dx                 ; la division ne se fait que sur AX
         div     cx                    ; division, le reste est en DX
         mov     [bp+2],ax             ; on sauve le quotient

         mov     ax,[bp]               ; mot de poids faible
         div     cx                    ; division DX:AX/CX, le digit est en DX
         mov     [bp],ax               ; sauve quotient

         add     dl,30h                ; conversion du digit en ASCII
         mov     [si],dl               ; criture dans chaine
         dec     si
         dec     bx

         cmp     word ptr [bp],0       ; teste si fini
         jne     ltoa_1                ; sinon, on boucle
         cmp     word ptr [bp+2],0
         jne     ltoa_1

         mov     cx,bx                 ; on remplit les digits non utiliss
ltoa_2:  mov     byte ptr [si]," "     ; par des espaces
         dec     si
         loop    ltoa_2

         pop     ax
         pop     dx
         pop     bp
         pop     si
         pop     di
         pop     cx
         pop     bx
         ret
ltoa     ENDP

Code     ends
         END    start                  ; That'a All Folks !

