;*****************************************************************************;
;*****************************************************************************;
;**                             95PANEL.ASM                                 **;
;**                        Configuration du HP95                            **;
;**                                                                         **;
;**   Dernire modification : 15/08/93        Auteur : Jacques Belin        **;
;**       Cration                                                          **;
;**                                                                         **;
;*****************************************************************************;
;*****************************************************************************;
         DOSSEG
code     segment para 'CODE'
         assume cs:code
         ORG    100h

start:   jmp    strt                   ; saut  la premire inst. excute

K_ENTER  EQU    000Dh                  ; code de la touche ENTER

Not_95   DB     "This program runs only on an HP95LX",13,10,0

                                       ; Ecran de prsentation
Dispstr  DB     13,9,"       HP95 Panel",13,10
         DB     10
         DB     "Volume       :",9,9,"Io",9,":",13,10
         DB     "Contrast     :",9,9,"Port",9,":",13,10
         DB     10
         DB     "Light sleep  :",9,9,"Baud",9,":",13,10
         DB     "Time out     :",9,"  mn",9,"bitS",9,":",13,10
         DB     9,9,9,"paRity",9,":",13,10
         DB     "cUrsor track :",9,9,"stOps",9,":",13,10
         DB     "Alt arrows   :",13,10
         DB     "",13,10
         DB     9,"     Total   Free   Batteries",13,10
         DB     "Mem",9,"  :",9,9,9,"(Main)",13,10
         DB     "Disk C",9,"  :",9,9,9,"(Backup)",13,10
s_CARD   DB     "Card      : Not Installed",0

P_VOL    EQU    0020Fh                 ; codes de position des donnes sur
P_CONT   EQU    0030Fh                 ;   l'cran, (voir fonction gotoxy)
P_SLEEP  EQU    0050Fh
P_TIME   EQU    0060Fh
P_CURS   EQU    0080Fh
P_ALT    EQU    0090Fh
P_IO     EQU    00222h
P_PORT   EQU    00322h
P_BAUD   EQU    00522h
P_BITS   EQU    00622h
P_PAR    EQU    00722h
P_STOP   EQU    00822h

P_TMEM   EQU    00C0Bh
P_FMEM   EQU    00C12h
P_BMAIN  EQU    00C1Bh
P_TDISK  EQU    00D0Bh
P_FDISK  EQU    00D12h
P_BBACK  EQU    00D1Bh
P_CARD   EQU    00E00h
P_RW     EQU    00E05h
P_TCARD  EQU    00E0Bh
P_FCARD  EQU    00E12h

s_IR     DB     "IR   ",0
s_RS232  DB     "RS232",0
                                       ; Codes du diviseur de frquence RS232
n_BAUD   DW     384                    ; 300    bauds
         DW     96                     ; 1200   bauds
         DW     48                     ; 2400   bauds
         DW     24                     ; 4800   bauds
         DW     12                     ; 9600   bauds
         DW     6                      ; 19200  bauds
         DW     2                      ; 57600  bauds
         DW     1                      ; 115200 bauds

s_PAR    DB     "NONE",0               ; Codes de parit
         DB     "ODD ",0
s_RW     DB     "    ",0               ; on utilise la chaine vide pour s_RW
         DB     "EVEN",0
L_PAR    EQU    5                      ; longueur chaines (y compris caract 0)

s_RO     DB     "(RO)",0

s_tmp    DB     "      ",0             ; stockage temporaire des nombres ASCII


keymap   DB     "v"                    ; table d'index des touches accessibles
         DB     "V"
         DB     "c"
         DB     "C"
         DB     "l"
         DB     "t"
         DB     "T"
         DB     "u"
         DB     "a"
         DB     "i"
         DB     "p"
         DB     "b"
         DB     "B"
         DB     "s"
         DB     "S"
         DB     "r"
         DB     "R"
lastkey  DB     "o"

vectors  DW     OFFSET incvol          ; Table des vecteurs vers les fonctions
         DW     OFFSET decvol          ;  de modification
         DW     OFFSET inccont
         DW     OFFSET deccont
         DW     OFFSET invslp
         DW     OFFSET inctime
         DW     OFFSET dectime
         DW     OFFSET invcurs
         DW     OFFSET invalt
         DW     OFFSET invio
         DW     OFFSET invport
         DW     OFFSET incbaud
         DW     OFFSET decbaud
         DW     OFFSET incbits
         DW     OFFSET decbits
         DW     OFFSET incpar
         DW     OFFSET decpar
         DW     OFFSET invstop


strt:    cld                           ; on assure l'effacement du flag D

         mov    ax,2524h               ; on remplace le vecteur de l'int 24h
         mov    dx,offset nocrd_0      ;   par celui de la routine nocrd_0
         int    21h

         mov    ah,4Ah                 ; on rjuste taille du bloc programme
         mov    bx,2048/16             ;   2048 octets (prgm + pile)
         int    21h
         mov    sp,2048                ; on replace le pointeur de pile

         mov    ax,40h                 ; on positionne ES sur le segment des
         mov    es,ax                  ;   donnes du BIOS

         mov    ax,4dd4h               ; vrification d'excution
         int    15h                    ;  sur HP95 (HP100 refus)
         cmp    bx,'HP'
         jne    main_1
         cmp    cx,0101h
         je     main_2                 ; si hp95, on passe
main_1:  mov    dx,OFFSET Not_95
         call   printf
         jmp    exit                   ; sortie du programme

main_2:  and    byte ptr es:[17h],10111111b ; assurer l'effacement du CAPS LOCK
         mov    ax,0007h               ; effacement de l'cran
         int    10h
         mov    dx,OFFSET Dispstr      ; affichage cran de prsentation
         call   printf
         call   dspvol                 ; affichages des donnes initiales
         call   dspcont
         call   dspslp
         call   dsptime
         call   dspcurs
         call   dspalt
         call   dspio
         call   dspport
         call   dspbaud
         call   dspbits
         call   dsppar
         call   dspstop

                                       ; AFFICHAGES INFORMATIONS MEMOIRE
main_3:  mov    ax,es:[013h]           ; affichage taille mmoire maxi
         mov    dx,offset P_TMEM
         call   dspspace

         mov    bx,0FFFFh              ; lecture mmoire disponible
         mov    ah,48h
         int    21h
         mov    ax,bx
         mov    cl,6                   ; conversion de paragraphes en Koctets
         shr    ax,cl                  ;  (shr ax,6 = ax*16/1024)
         inc    ax                     ; on ajoute les 2ko rservs par 95panel
         inc    ax
         mov    dx,offset P_FMEM       ; affichage de la mmoire dispo
         call   dspspace

         mov    al,0                   ; affichage tension bat. principales
         mov    dx,offset P_BMAIN
         call   dispbat

         mov    al,1                   ; affichage tension pile backup
         mov    dx,offset P_BBACK
         call   dispbat

         mov    dl,3                   ; AFFICHAGE INFOS DISQUE C
         call   diskspce               ; lecture capacits totale et disponible
         push   bx                     ; sauve capacit disponible
         mov    dx,offset P_TDISK      ; affichage capacit totale
         call   dspspace
         pop    ax                     ; on rcupre capacit disponible dans AX
         mov    dx,offset P_FDISK      ; affichage
         call   dspspace

                                       ; AFFICHAGE INFOS CARTE
         mov    dx,0E304h              ; Lecture des infos du port PCMCIA
         in     al,dx
         test   al,01000000b           ; Carte prsente ?
         jnz    main_5                 ; oui, saut vers affichage infos cartes
main_4:  mov    dx,P_CARD              ; non, affichage "not installed"
         call   gotoxy
         mov    dx,offset s_CARD       
         call   printf
         jmp    main_7
         ;------------
main_5:  mov    dx,P_RW                ; positionnement curseur aprs "card"
         call   gotoxy
         mov    dx,offset s_RW         ; DX pointe sur chaine vide
         test   al,00010000b           ; criture autorise ?
         jnz    main_6
         mov    dx,offset s_RO         ; DX pointe sur "(RO)"
main_6:  call   printf                 ; affichage
         mov    dl,1                   ; lecture capacits totale et disponible
         call   diskspce               
         jc     main_4                 ; si carry, erreur -> aff "not installed"
         push   bx                     ; sauve capacit disponible
         mov    dx,offset P_TCARD      ; affichage capacit totale
         call   dspspace
         pop    ax                     ; on rcupre capacit disponible dans AX
         mov    dx,offset P_FCARD      ; affichage
         call   dspspace

main_7:  mov    dx,00F00h              ; positionne curseur sur derniere ligne
         call   gotoxy

                                       ; LECTURE DU CLAVIER
main_8:  mov    ah,11h                 ; lecture tat du clavier
         int    16h
         jnz    main_a                 ; si touche dans buffer -> traitement
                                       ; TEST DU TRAITEMENT DE LA TOUCHE "ON"
         mov    bx,es:[1Ah]            ; lecture addresse dernire touche
         dec    bx                     ;   place dans buffer
         dec    bx
         cmp    bx,1Eh                 ; (ajustement sur le buffer circulaire)
         jae    main_9
         mov    bx,3Ch
main_9:  cmp    word ptr es:[bx],0A000h ; La touche ON a-t-elle t presse ?
         jne    main_8                 ; non, on reprend scrutation du clavier
         mov    word ptr es:[bx],0h    ; oui, on efface le code (car on
                                       ;  repassera dessus au cours de la
                                       ;  prochaine boucle)...
         jmp    main_3                 ; ...puis on raffiche les infos carte

                                       ; TRAITEMENT DE LA TOUCHE PRESSEE
main_a:  mov    ah,10h                 ; Lecture du buffer clavier
         int    16h                    
         cmp    al,0                   ; code tendu ?
         je     main_c                 ;   oui, pas touche pas utilise
         cmp    al,K_ENTER             ; touche ENTER ?
         je     exit                   ;   oui, sortie du programme
         mov    si,offset keymap       ; SI = base de la table des touches
main_b:  cmp    [si],al                ; touche presse = entre table ?
         je     main_d                 ; oui, on traite
         inc    si                     ; non, on pointe sur entre suivante
         cmp    si,offset lastkey      ; a-t-on dpass la dernire entre ?
         jbe    main_b                 ; non, on boucle
main_c:  jmp    main_7                 ; oui: mauvaise touche -> on retourne
         ;--------------               ;   a la scrutation
main_d:  sub    si,offset keymap       ; on rcupre l'index dans la table
         shl    si,1                   ; multiplication index par 2 (byte->word)
         call   ds:[si+offset vectors] ; appel de la routine de traitement+aff
         jmp    main_7                 ; retour  la scrutation du clavier
         ;--------------

exit:    mov    ah,4ch                 ; retour au DOS
         int    21h
         ;---------

;************************ SOUS-PROGRAMMES ***********************
                                       ; TRAITEMENT ET AFFICHAGE DU VOLUME
incvol:  call   getE309                ; lecture valeur courante
         inc    al                     ; incrmentation
         jmp    decvo_1
         ;--------------
decvol:  call   getE309                ; lecture valeur courante
         dec    al                     ; dcrmentation
decvo_1: and    al,00000011b           ; on garde que les 2 bits de poids faible
         mov    ah,48h                 ; criture nouvelle valeur
         int    15h
         mov    dl,7                   ; BEEP !
         call   putch
dspvol:  call   getE309                ; lecture valeur courante
         mov    cx,offset P_VOL
dspvo_1: xor    ah,ah                  ; on assure AH = 0
         mov    bx,2                   ; on n'affichera que deux caractres maxi
         xor    dx,dx                  ; seul AX est utilis
         jmp    displeft               ; affichage
         ;--------------

                                       ; TRAITEMENT ET AFFICHAGE DU CONTRASTE
inccont: call   getE309                ; lecture valeur courante
         inc    bl                     ; incrmentation
         jmp    decco_1
         ;-------------
deccont: call   getE309                ; lecture valeur courante
         dec    bl                     ; dcrmentation
decco_1: and    bx,00001111b           ; on garde que les 4 bits de poids faible
         mov    ax,4700h               ; slection nouvelle valeur
         int    15h
dspcont: call   getE309                ; lecture valeur courante
         mov    ax,bx                  ; contraste dans AX
         mov    cx,offset P_CONT       ; saut dans routine d'affichage du volume
         jmp    dspvo_1
         ;------------

                                       ; TRAITEMENT+AFFICHAGE DU LIGHT SLEEP
invslp:  xor    byte ptr es:[0D6h],00000001b ; inversion valeur courante
dspslp:  mov    al,es:[0D6h]           ; lecture valeur courante
         mov    dx,offset P_SLEEP      ; saut dans routine d'affichage Alt Arrows
         jmp    dspal_1
         ;-------------

                                       ; TRAITEMENT+AFFICHAGE DU TIME OUT
inctime: add    es:[0A3h],1092         ; incrmentation valeur courante
         jmp    dsptime                ;   (1092 ticks = 60 secondes)
         ;-------------
dectime: sub    es:[0A3h],1092         ; dcrmentation valeur courante
dsptime: mov    ax,es:[0A3h]           ; lecture valeur courante
         add    ax,20                  ; petit offset
         mov    cx,60                  ; multiplication valeur courante par 60
         mul    cx                     ;   (DX contiendra le temps en minutes)
         mov    ax,dx                  ; AX = temps en minutes
         mov    cx,offset P_TIME       ; saut dans routine d'affichage du volume
         jmp    dspvo_1
         ;------------

                                       ; TRAITEMENT+AFFICHAGE CURSOR TRACKING
invcurs: xor    byte ptr es:[93h],00000010b ; inversion du bit cursor tracking
dspcurs: mov    al,es:[93h]            ; lecture valeur courante
         shr    al,1                   ; dcalage d'un bit
         mov    dx,offset P_CURS       ; saut dans routine d'affichage Alt Arrows
         jmp    dspal_1
         ;-------------

                                       ; TRAITEMENT+AFFICHAGE ALT ARROWS
invalt:  xor    byte ptr es:[93h],00000001b  ; inversion du bit alt arrows
dspalt:  mov    al,es:[93h]            ; lecture valeur courante
         mov    dx,offset P_ALT
dspal_1: and    al,1                   ; on ne garde que le bit de poids faible
         xor    al,1                   ; on inverse le bit (c'est invers en mem)
         jmp    dispi_1                ; affichage de ON ou OFF
         ;------------

                                       ; TRAITEMENT+AFFICHAGE ACTIVATION PORT
invio:   mov    dx,0E301h              ; lecture valeur courante
         in     al,dx
         xor    al,00000100b           ; inversion du bit
         out    dx,al                  ; rcriture nouvelle valeur
dspio:   mov    dx,0E301h              ; lecture valeur courante
         in     al,dx
         shr    al,1                   ; dcalage de 2 bits
         shr    al,1
         and    al,1                   ; on ne garde que le bit de poids faible
         mov    dx, offset P_IO        ; affichage de ON ou OFF
dispi_1: jmp    dispon
         ;------------

                                       ; TRAITEMENT+AFFICHAGE SELECTION PORT
invport: mov    dx,0E30Ah              ; lecture valeur courante
         in     al,dx
         xor    al,00000100b           ; inversion du bit correspondant
         out    dx,al                  ; rcriture nouvelle valeur
dspport: mov    dx,0E30Ah              ; lecture valeur courante
         in     al,dx
         shr    al,1                   ; dcalage de 2 bits
         shr    al,1
         and    al,1                   ; on ne garde que le bit de poids faible
         mov    dx,offset P_PORT
         call   gotoxy                 ; positionnement curseur
         mov    dx,offset s_IR
         cmp    al,1                   ; bit = 1 ?
         je     dspor_1
         mov    dx,offset s_RS232      ; non, on travaille en RS232
dspor_1: jmp    printf                 ; affichage
         ;------------

                                       ; TRAITEMENT+AFFICHAGE DE LA VITESSE
incbaud: call   getsrial               ; lecture valeur courante
         inc    bx                     ; incrmentation
         jmp    decba_1
         ;-------------
decbaud: call   getsrial               ; lecture valeur courante
         dec    bx                     ; dcrmentation
decba_1: and    bx,00000111b           ; on garde que les 3 bits de poids faible
         call   setsrial               ; slction nouvelle valeur
dspbaud: call   getsrial               ; lecture valeur courante
         shl    bl,1                   ; multiplication par 2 pour accs table
         mov    cx,ds:[bx+offset n_BAUD] ; diviseur dans CX
         mov    dx,1                   ; DX:AX = 115200
         mov    ax,0C200h
         cmp    cx,1                   ; on saute 115200/1 (pas possible
         je     dspba_1                ;  sur 80x86)
         div    cx                     ; on divise 115200 par le diviseur
dspba_1: mov    cx,offset P_BAUD       ; affichage
         mov    bx,6
         jmp    displeft
         ;--------------

                                       ; TRAITEMENT+AFFICHAGE DU NBRE DE BITS
incbits: call   getsrial               ; lecture valeur courante
         inc    dx                     ; incrmentation
         jmp    decbi_1
         ;-------------
decbits: call   getsrial               ; lecture valeur courante
         dec    dx                     ; dcrmentation
decbi_1: and    dl,00000011b           ; on garde que les 2 bits de poids faible
         call   setsrial
dspbits: call   getsrial               ; lecture valeur courante
         mov    al,dl
         add    al,5
         mov    cx,offset P_BITS       ; saut dans routine d'affichage du volume
         jmp    dspvo_1
         ;------------

                                       ; TRAITEMENT+AFFICHAGE DE LA PARITE
incpar:  call   getsrial               ; lecture valeur courante
incpa_1: inc    ax                     ; incrmentation
         cmp    al,00000010b           ; si al = 2..
         je     incpa_1                ; ..on incrmente encore une fois
         jmp    decpa_2
         ;-------------
decpar:  call   getsrial               ; lecture valeur courante
decpa_1: dec    ax                     ; dcrmentation
         cmp    ax,00000010b           ; si al = 2..
         je     decpa_1                ; ..on dcrmente encore une fois
decpa_2: and    al,00000011b           ; on garde que les 2 bits de poids faible
         call   setsrial               ; criture nouvelle valeur
dsppar:  call   getsrial               ; lecture valeur courante (dans AL)
         mov    cl,L_PAR               ; cl = longueur chaine (y compris code 0)
         mul    cl                     ; AX = AL * CX = offset dans table
         add    ax,offset s_PAR        ; AX = adresse chaine
         mov    dx,offset P_PAR        ; positionnement curseur
         call   gotoxy
         mov    dx,ax                  ; affichage
         jmp    printf
         ;------------

                                       ; TRAITEMENT+AFFICHAGE DES BITS STOP
invstop: call   getsrial               ; lecture valeur courante
         xor    cl,00000001b           ; inversion du bit
         call   setsrial               ; criture nouvelle valeur
dspstop: call   getsrial               ; lecture valeur courante
         mov    al,cl                  ; on ajoute 1 (pour afficher 1 ou 2)
         inc    al
         mov    cx,offset P_STOP       ; saut dans routine d'affichage du volume
         jmp    dspvo_1
         ;-------------

                                       ; ROUTINE DE GESTION DE L'INT 24H
nocrd_0: mov    al,3                   ;  si activ, on retourne FAIL
         iret                          ; retour  la routine DOS ayant dtect
         ;---                          ;   l'erreur



;****************************************************
; GETe309 : dcode les informations du port E309
; entres : aucune
; sorties : AL = Volume
;           BX = Contraste
; Note    : AH perdu
; Note    : REGISTRES CX, DX NON CONSERVES
;****************************************************
getE309  PROC   NEAR
         mov    dx,0E309h              ; Lecture du port
         in     al,dx                  ; (AL = CCCCVVxx)
         mov    cl,2                   ; cl = valeur de dcalage
         shr    al,cl                  ; AL = 00CCCCVV
         mov    bl,al                  ; BL = 00CCCCVV
         and    al,00000011b           ; AL = 000000VV
         shr    bl,cl                  ; BL = 0000CCCC
         xor    bh,bh
         ret
getE309  ENDP


;****************************************************
; GETSRIAL : donne la configuration de la RS232
; entres : aucune
; sorties : AX = parit  : 0 =  None
;                          1 =  Impaire (ODD)
;                          3 =  Paire (EVEN)
;           BX = Vitesse : 0 =    300 bauds
;                          1 =   1200 bauds
;                          2 =   2400 bauds
;                          3 =   4800 bauds
;                          4 =   9600 bauds
;                          5 =  19200 bauds
;                          6 =  57600 bauds
;                          7 = 115200 bauds
;           CX = bits stops : 0 = 1 bit stop
;                             1 = 2 bits stops
;           DX = Donnes : 0 =   5 bits donnes
;                          1 =   6 bits donnes
;                          2 =   7 bits donnes
;                          3 =   8 bits donnes
;****************************************************
getsrial PROC   NEAR
         mov    dx,03FBh               ; lecture du port de configuration
         push   dx
         in     al,dx
         push   ax                     ; on sauve la configuration courantes

         mov    cl,al                  ; sauvegarde config dans CX
         or     al,10000000b           ; on arme le bit DLAB
         out    dx,al

         mov    dl,0F8h                ; lecture du diviseur courant
         in     ax,dx
         xor    bx,bx                  ; on initialise l'index  0
getsr_1: cmp    ds:[bx+offset n_BAUD],ax ; diviseur courant = entre table ?
         jbe    getsr_2                ; oui, on a trouv le code
         inc    bx                     ; non, on passe  l'entre courante
         inc    bx
         jmp    getsr_1                ; on boucle...
         ;-------------
getsr_2: shr    bx,1                   ; conversion index en code
         
         pop    ax                     ; restauration contenu du port 3fb
         pop    dx
         out    dx,al

         mov    dl,cl                   ; nombre de bits de donnes dans DX
         and    dx,00000011b

         shr    cl,1                    ; nombre de bits stop dans CX
         shr    cl,1
         mov    al,cl
         and    cx,00000001b

         shr    al,1                    ; parit dans AX
         and    ax,00000011b
         ret
getsrial ENDP


;****************************************************
; SETSRIAL : configure la RS232
; entres : AX, BX, CX, DX = voir sorties GETSRIAL
; sorties : aucune
; Note    : REGISTRES AX, BX, CX, DX NON CONSERVES
;****************************************************
setsrial PROC   NEAR
         push   dx
         push   ax

         mov    al,80h                 ; on arme le bit DLAB du port 3FB
         mov    dx,03fbh               ;  avant d'ecrire la vitesse en 3f8
         push   dx
         out    dx,al

         shl    bx,1                   ; ecriture du diviseur en 3f8
         mov    ax,ds:[bx+offset n_BAUD]
         mov    dl,0F8h
         out    dx,ax

         pop    dx                     ; on rcupre 03FB dans dx
         pop    ax                     ; on rcupre le AX initial
         shl    al,1                   ; AL = 00000PP0
         or     al,cl                  ; AL = 00000PPS
         shl    al,1                   ; AL = 0000PPS0
         shl    al,1                   ; AL = 000PPS00
         pop    cx                     ; on rcupre le DX initial dans CX
         or     al,cl                  ; AL = 000PPSLL
         out    dx,al                  ; ecriture du nouveau mot de controle

         ret
setsrial ENDP


;****************************************************
; DISKSPCE  : renvoie les capacits totale et disponible
;            d'un disque
; entres : DL = numro du disque (A=1, B=2, C=3..)
; sorties : AX = capacit totale (en ko)
;           BX = Capacit disponible (en ko)
;           Si carry arm : erreur -> donnes non valides
; Note : on assume que les secteurs font 512 octets
;      : capacits limites  32Mo
; Note    : REGISTRES CX, DX NON CONSERVES
;****************************************************
diskspce PROC   NEAR
         mov    ah,36h                 ; appel de la fonction DOS de lecture
         int    21h                    ;   des capacits du disque
         cmp    ax,0FFFFh              ; si ax = FFFF -> erreur
         je     disks_3
                                       ; Rapel : La fonction 36h retourne :
                                       ;  AX = nbre de secteurs/cluster
                                       ;  BX = Capacit dispo (en clusters)
                                       ;  CX = Taille de secteurs en octets
                                       ;  DX = capacit totale du disque

                                       ; AX (clusters/sect) ne contient que
                                       ;  1, 2, 4, 8.. (1b, 10b, 100b, 1000b...)
                                       ;  on va en profiter...
disks_1: shr    ax,1                   ; dernier bit transfr dans Carry
         jc     disks_2                ; si carry, plus de multiplications
         shl    bx,1                   ; on multiplie capacits par deux
         shl    dx,1
         jmp    disks_1                ; et on boucle
         ;-------------

disks_2: shr    bx,1                   ; on divise les capacits par deux
         shr    dx,1                   ;  et on obtient directement des Ko
         mov    ax,dx
         clc                           ; pas d'erreur -> efface Carry
         jmp    disks_4
         ;-------------

disks_3: stc                           ; si erreur -> on arme le Carry
disks_4: ret
diskspce ENDP


;****************************************************
; DISPLEFT : affiche un nombre entier long, justifi  gauche
;            (maxi 6 digits). Place des blancs en fin de
;            chaine
; entres : DX:AX = nombre  afficher
;           BX = nombre de caractre de la chaine
;           CH,CL = position sur l'cran
; sortie  : Aucune
; Note    : Assume flag D  0
; Note    : REGISTRES AX, BX, CD, DX, SI NON CONSERVES
;****************************************************
displeft PROC   NEAR
         push   bx                     ; on sauve nombre de caractres dsir

         push   dx                     ; on sauve le mot de poids fort
         mov    dx,cx                  ; on positionne le curseur
         call   gotoxy
         pop    dx                     ; on rcupre le mot de poids fort

         mov    bx,6
         mov    si,offset s_tmp        ; conversion en ascii dans s_tmp
         call   ltoa                   ;   (cadr  droite)

displ_1: lodsb                         ; lecture du caractre en DS:SI (+inc si)
         cmp    al," "                 ;   si espace, on boucle
         je     displ_1

         dec    si                     ; on annule le dernier dcalage
         mov    dx,si                  
         call   printf                 ; affichage chaine
         call   strlen                 ; calcul longueur utile de la chaine

         pop    dx                     ; rcupration nbre de caractres dsir
         sub    dx,cx                  ; cx = cx - longueur chaine
         mov    cx,dx
         jz     displ_3                ; si rsultat = 0, pas d'espaces en plus

         mov    ah,02h                 ; affichage de 'CX' caractre espace
         xor    bx,bx
         mov    dl," "
displ_2: int    21h                    
         loop   displ_2

displ_3:
         ret
displeft ENDP

;****************************************************
; DISPON  : affiche ON ou OFF suivant le contenu de AL
; entres : AL = 0 ou 1
;           DH,DL = position sur l'cran
; sortie  : Aucune
; Note    : REGISTRES DX NON CONSERVE
; NOTE    : LE CODE CONTINUE DANS PRINTF
;****************************************************
s_ON     DB     "ON ",0
s_OFF    DB     "OFF",0

dispon   PROC   NEAR
         call   gotoxy                 ; on positionne le curseur
         mov    dx,offset s_ON         ; initialise dx sur "ON"
         cmp    al,1                   ; si al diffrent de 1..
         je     dispo_1
         mov    dx,offset s_OFF        ; ..on initialise dx sur "OFF"
dispo_1:                               ; le code continue fonction suivante !
dispon   ENDP


;****************************************************
; PRINTF  : affiche une chaine de caractres dans
;           le flux standard stdout
; entres : DS:DX = Chaine
; sortie  : Aucune
;****************************************************
printf   PROC   NEAR
         push   ax
         push   bx
         push   cx
         call   strlen                 ; calcul de la longueur de la chaine
         mov    ah,40h                 ; affichage
         mov    bx,1
         int    21h
         pop    cx
         pop    bx
         pop    ax
         ret
printf   ENDP


;****************************************************
; DISPBAT  : affiche la tension des batteries
; entres : AL = baterie (main=0, backup=1, carte=2)
;           DX = position de la chaine  l'cran
; sortie  : Aucune
; Note    : REGISTRES AX, DX NON CONSERVES
; NOTE    : LE CODE CONTINUE DANS PUTCH
;****************************************************
dispbat  PROC   NEAR
         call   gotoxy                 ; positionnement du curseur

         mov    ah,50h                 ; lecture de la tension de la batterie
         int    15h
         xor    ah,ah                  ; conversion en diximes de volts
         mov    dl,5
         div    dl
         dec    ax
         cmp    al,19
         jnb    dispb_1
         inc    ah
         cmp    al,14
         jnb    dispb_1
         inc    ah
dispb_1: aam                           ; conversion en 2 codes ASCII
         add    ax,3030h
         mov    cx,ax
         mov    dl,ch
         call   putch                  ; affichage des volts
                                       ; note : on profite ici que les registres
                                       ;  ne sont pas restitus par putch
         mov    dl,"."                 ; affichage du point dcimal
         int    21h
         mov    dl,cl                  ; affichage des diximes de volts
         int    21h
         mov    dl,"V"                 ; affichage du "V" final
         jmp    putch
dispbat  ENDP


;****************************************************
; DSPSPACE : affiche une capacit (mmoire ou disque)
;           justifie  droite, suivie de la lettre 'K'
; entres : AX = nombre  afficher
;           DH,DL = position sur l'cran
; sortie  : Aucune
; Note    : REGISTRES AX, BX, CX, DX, SI  NON CONSERVES
; NOTE    : LE CODE CONTINUE DANS PUTCH
;****************************************************
dspspace PROC   NEAR
         call   gotoxy                 ; positionnement du curseur
         mov    si,offset s_tmp        ; si pointe sur chaine de stockage
         mov    bx,6                   ; conversion AX en chaine, dans s_tmp
         xor    dx,dx
         call   ltoa
         mov    dx,si                  ; affichage chaine
         call   printf
         mov    dl,"K"                 ; affichage du "K" final
dspspace ENDP                          ; on continue dans la fonction suivante !

;****************************************************
; PUTCH   : affiche un caractre
; entres : DL = Code du caractre
; sortie  : Aucune
; Note    : REGISTRES AX, BX  NON CONSERVES
;           (possibilit utilise dans dispbat !)
;****************************************************
putch    PROC   NEAR
         mov    ah,02h
         xor    bx,bx
         int    21h
         ret
putch    ENDP


;****************************************************
; GOTOXY  : positionnement du curseur
; entres : DH = ligne
;           DL = Colonne
; sortie  : Aucune
;****************************************************
gotoxy   PROC   NEAR
         push   ax
         push   bx
         push   dx

         mov    ah,02h
         xor    bx,bx
         int    10h

         pop    dx
         pop    bx
         pop    ax
         ret
gotoxy   ENDP


;****************************************************
; STRLEN  : calcule la longueur d'une chaine
; entres : DS:DX adresse de la chaine
; retour  : CX = longueur                                
;****************************************************
strlen   PROC   NEAR
         push   bx

         xor    cx,cx
         mov    bx,dx
strle_1: cmp    byte ptr [bx],0        ; fin de la chaine ?
         je     strle_2                ; oui -> fin de routine
         inc    cx                     ; incrmentation taille
         inc    bx                     ; on pointe sur caractre suivant
         jmp    strle_1                ; on boucle...
         ;-------------
         
strle_2: pop    bx
         ret
strlen   ENDP


;================================================
; LTOA : Conversion d'un entier long en chaine
;        justifie  droite
;        Pas de code de fin de chaine ('\0')
; Entres: DX:AX = nombre  convertir
;          BX = nombre de digits total
;          DS:SI = Adresse du dbut de chaine
;================================================
ltoa     PROC   NEAR
         push   ax
         push   bx
         push   cx
         push   dx
         push   di
         push   si
         push   bp

         mov    di,dx                  ; on sauve DX:AX dans DI:BP
         mov    bp,ax

         add    si,bx                  ; calcul position du dernier caractre
         dec    si                     ;  de la chaine (digit poids faible)

         mov    cx,10                  ; diviseur (base)

ltoa_1:  mov    ax,di                  ; on rcupre le mot de poids fort
         xor    dx,dx                  ; la division ne se fait que sur AX
         div    cx                     ; division, le reste est en DX
         mov    di,ax                  ; on sauve le quotient

         mov    ax,bp                  ; mot de poids faible
         div    cx                     ; division DX:AX/CX, le digit est en DX
         mov    bp,ax                  ; sauve quotient

         add    dl,30h                 ; conversion du digit en ASCII
         mov    [si],dl                ; criture dans chaine
         dec    si
         dec    bx
         jz     ltoa_3                 ; on arrete si nbre de caractres atteint

         mov    ax,bp                  ; si BP ou DI differents de 0..
         or     ax,di
         jnz    ltoa_1                 ; ..on continue le dcodage

         mov    cx,bx                  ; on remplit les digits non utiliss
ltoa_2:  mov    byte ptr [si]," "      ; par des espaces
         dec    si
         loop   ltoa_2

ltoa_3:  pop    bp
         pop    si
         pop    di
         pop    dx
         pop    cx
         pop    bx
         pop    ax
         ret
ltoa     ENDP

Code     ends
         END    start                  ; That's All Folks !


