/*****************************************************************************/
/*****************************************************************************/
/**                            PENDUL.POV                                   **/
/**             Pendule HP95 (sources Persistence of Vision)                **/
/**                                                                         **/
/**    dernire modification : 23/05/94            Auteur : Jacques Belin   **/
/**           Changement texture sphere                                     **/
/**                                                                         **/
/*****************************************************************************/
/*****************************************************************************/

#include "colors.inc"              // Fichiers de dclaration des couleurs,
#include "textures.inc"            //   textures et formes standard
#include "shapes.inc"

#include "pendul.inc"              // Contient les valeurs changeant au cours
                                   //   de l'animation. Pour ce fichier, ce
                                   //   sera :
                                   //     #declare angle = xx
                                   //   avec "xx" dfini par RTAG.

#declare RayonSphere = 28          //  dimension des lments
#declare LenBal = 100


camera                             // Dclaration de la camra (position,
  {                                //    point vis....)
   location <0.0,  0.0,  -100.0>
   up  <0.0,  1.0,  0.0>
   right <1.875, 0.0, 0.0>
   look_at <0, 0, 0>
  }


#declare Sphere1 =                 // Dclaration de la sphre
object
  {
   sphere { <0.0, 0.0, 0.0> RayonSphere }   // position, dimension
   texture                         // Texture base sur celle du verre
     {                             //  mais modifie tre visible sur HP95
      pigment { color red 0.9 green 0.9 blue 0.9 filter 0.6 }
      finish
        {
         Shiny
         roughness 0.02
         ambient 0.0
         diffuse 1.2
         refraction 0.8
         reflection 0.05
         specular 0.7
         crand 0.05
         ior 1.5
        }
     }
  }


#declare Fil =                     // Dclaration du fil du balancier
object
  {
   cylinder
     {
      <0, 0, 0>                    // longueur
      <0, LenBal, 0>
      5.0                          // Diametre = 5
      pigment
        {
         Pine_Wood
        }
     }
  }


union                   // Union des deux lments en un seul objet avec
  {                     //   positionnement adquat de l'un par rapport
                        //    l'autre. L'origine (qui sert de centre de
                        //   rotation est en haut du fil.
   object  { Fil     translate < 0.0, -90, 0.0 > }
   object  { Sphere1 translate < 0.0, -100, 0.0 > }
   rotate <0.0, 0.0, angle>        // Rotation autour de l'axe d'origine
   translate <0.0, 90, -15.0>      // Dplacement du centre de l'"objet"
                                   //   au dessus du centre de l'cran
  }


                                   // Dfinition du fond de l'image
object
  {
   plane { <0.0, 0.0, 1.0> 0.0 }   // Dfinition d'un plan paralle 
                                   //   l'cran
   texture
     {
      finish                       // On ajuste ses proprits optiques
        {                          //   (pour la diffusion des ombres)
         ambient 0.7
         diffuse 1.0
        }
      pigment                      // On y "colle" une image
        {
         image_map { gif "logoppc.gif" once }
        }
      scale < 188.0, 110.0, 1.0 >  // On ajuste la taille de facon  remplir
                                   //   l'cran
      translate <-94, -55, 100>    // On ajuste la position
     }
  }

object                             // Dfinition de la source de lumire
  {
   light_source
     {
      <-1000.0,  1000.0,  -1000.0>
      colour White
     }
  }


