/*****************************************************************************/
/*****************************************************************************/
/**                R8TOIBM (filtre de conversion Roman8-IBM)                **/
/**                                                                         **/
/**   cration : 08/03/90                      Auteur : JB                  **/
/**                                                                         **/
/**   07/06/92 : Passage table de conversion en ".h"                        **/
/**                                                                         **/
/*****************************************************************************/
/*****************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include "getopt.c"
#include "r8_pc850.h"

/*****************************************************************************/
/** Table de conversion                                                      **/
/*****************************************************************************/
                                                             /*Codes ASCII*/
unsigned char *tab=r8_pc850;


void main(int argc, char *argv[])
  {
   unsigned char ci, co;
   int conv_tabs = 0;
   char c;
   int errflag=0;

   while((c=getopt(argc, argv, "t")) != EOF)
     {
      switch(c)                                   /* selection des options */
        {
         case 't' : conv_tabs = 1;
                    break;

         case '?' : errflag++;
                    break;
        }
     }

   if(optind != argc)
      errflag++;

   if(errflag)                                   /* sortie en cas d'erreur */
     {
      fprintf(stderr, "usage : r8toibm [-t] <infile >outfile\n");
      exit(-1);
     }

   do
     {
      ci = (unsigned char) getc(stdin);
      switch((char) ci)
        {
         case '\t' : if(conv_tabs)
                        fputs("        ", stdout);
                     else
                        putc((int) ci, stdout);
                     break;

         case EOF  : break;

         default   : co = (ci > 127) ? tab[ci-128] : ci;
                     putc((int) co, stdout);
                     break;
        }
     }
   while(ci != ((unsigned char)EOF));
  }

