;*****************************************************************************
;**                                T J R 8                                  **
;**  Conversion en Roman8 des caractres imprims sur ThinkJet Par HP-LINK  **
;**                                                                         **
;**    Cration le 10/06/92               Auteur : Jacques Belin            **
;**                                   (d'aprs PRCO de Michael Tischer)     **
;**    Dernire modif.: 03/07/92                                            **
;**        Modification de la dsinstallation : Ajout de l'option "U"       **
;*****************************************************************************

;== Ici commence le programme vritable ================================

code      segment para 'CODE'     ;Dfinition du segment de CODE

          org  100h

          assume cs:code, ds:code, es:code, ss:code

start:    jmp   prcoini           ;La premire instruction excute

;== Donnes (restent en mmoire) ======================================

ancint    equ  this dword         ;Ancien vecteur d'interruption 21h
ofsancint dw   (?)                ;Adresse d'offset vecteur d'interruption 21h
segancint dw   (?)                ;Adresse de segment vecteur d'interr. 21h

          ;-- Table de conversion PC850->Roman8 ------------------------

codetab   label byte
          db   180                ;code 128
          db   207                ;code 129
          db   197                ;code 130
          db   192                ;code 131
          db   204                ;code 132
          db   200                ;code 133
          db   212                ;code 134
          db   181                ;code 135
          db   193                ;code 136
          db   205                ;code 137
          db   201                ;code 138
          db   221                ;code 139
          db   209                ;code 140
          db   217                ;code 141
          db   216                ;code 142
          db   208                ;code 143
          db   220                ;code 144
          db   215                ;code 145
          db   211                ;code 146
          db   194                ;code 147
          db   206                ;code 148
          db   202                ;code 149
          db   195                ;code 150
          db   203                ;code 151
          db   239                ;code 152
          db   218                ;code 153
          db   219                ;code 154
          db   214                ;code 155
          db   187                ;code 156
          db   210                ;code 157
          db   '?'                ;code 158
          db   190                ;code 159
          db   196                ;code 160
          db   213                ;code 161
          db   198                ;code 162
          db   199                ;code 163
          db   183                ;code 164
          db   182                ;code 165
          db   249                ;code 166
          db   250                ;code 167
          db   185                ;code 168
          db   '?'                ;code 169
          db   '?'                ;code 170
          db   248                ;code 171
          db   247                ;code 172
          db   184                ;code 173
          db   251                ;code 174
          db   253                ;code 175
          db   '?'                ;code 176
          db   127                ;code 177
          db   '?'                ;code 178
          db   '|'                ;code 179
          db   '|'                ;code 180
          db   224                ;code 181
          db   162                ;code 182
          db   161                ;code 183
          db   '?'                ;code 184
          db   '?'                ;code 185
          db   '?'                ;code 186
          db   '?'                ;code 187
          db   '?'                ;code 188
          db   191                ;code 189
          db   188                ;code 190
          db   '?'                ;code 191
          db   '?'                ;code 192
          db   '?'                ;code 193
          db   '?'                ;code 194
          db   '|'                ;code 195
          db   246                ;code 196
          db   '+'                ;code 197
          db   226                ;code 198
          db   225                ;code 199
          db   '?'                ;code 200
          db   '?'                ;code 201
          db   '?'                ;code 202
          db   '?'                ;code 203
          db   '?'                ;code 204
          db   '='                ;code 205
          db   '?'                ;code 206
          db   186                ;code 207
          db   228                ;code 208
          db   227                ;code 209
          db   164                ;code 210
          db   165                ;code 211
          db   163                ;code 212
          db   '?'                ;code 213
          db   229                ;code 214
          db   166                ;code 215
          db   167                ;code 216
          db   '?'                ;code 217
          db   '?'                ;code 218
          db   '?'                ;code 219
          db   '?'                ;code 220
          db   124                ;code 221
          db   230                ;code 222
          db   '?'                ;code 223
          db   231                ;code 224
          db   222                ;code 225
          db   223                ;code 226
          db   232                ;code 227
          db   234                ;code 228
          db   233                ;code 229
          db   243                ;code 230
          db   241                ;code 231
          db   240                ;code 232
          db   237                ;code 233
          db   174                ;code 234
          db   173                ;code 235
          db   178                ;code 236
          db   177                ;code 237
          db   176                ;code 238
          db   168                ;code 239
          db   '-'                ;code 240
          db   254                ;code 241
          db   '_'                ;code 242
          db   245                ;code 243
          db   244                ;code 244
          db   189                ;code 245
          db   '?'                ;code 246
          db   '?'                ;code 247
          db   179                ;code 248
          db   171                ;code 249
          db   242                ;code 250
          db   '?'                ;code 251
          db   '?'                ;code 252
          db   '?'                ;code 253
          db   252                ;code 254
          db   160                ;code 255

;== Voici la nouvelle interruption imprimante (reste en mmoire) =======

newpri    proc far

          jmp  short newpri_1

          db   "TJ"               ;Identification du programme

newpri_1: cmp  ah,05h             ;Imprimer caractre (Fonction 5) ?
          je   dos_imp            ;OUI --> routine fonction 5

          cmp  ah,40h             ;fonction Handle ? (Fonction 40) ?
          jne  ioctl              ;NON --> tester si c'est un IOCTL
          cmp  bx,4               ;Handle 4 (stdprn) ?
          je   handle             ;OUI --> c'est le bon handle

ioctl:    cmp  ah,44h             ;fonction IOCTL ? (Fonction 40) ?
          jne  aint               ;NON --> Appeler ancienne interruption
          cmp  al,3               ;fonction d'ecriture d'un caractre ?
          jne  aint               ;NON --> Appeler ancienne interruption
          cmp  bx,4               ;Handle 4 (stdprn) ?
          jne  aint               ;NON --> Appeler ancienne interruption
          ;Traitement de la fonction d'ecriture sur stdprn par handle

handle:   cmp  cx,0               ;0 octets  ecrire ?
          je   aint               ;OUI --> Appeler ancienne interruption


          pushf                   ;Tous les registres modifis par la
          push ax                 ;suite doivent tre sauvegards
          push bx
          push cx
          push dx
          push es
          push di
          push bp
          push si

          push cs                 ;Ranger CS sur la pile
          pop  es                 ;Retirer de la pile pour DS

          mov  bp,dx              ;transfert de l'offset buffer dans bp
          mov  si,cx              ;transfert nbre d'octets  ecrire dans si

          xor  bh,bh              ;on efface l'octet de poids fort

loop1 :   mov  bl,ds:[bp+si-1]    ;lecture prochain caractre du buffer
          cmp  bl,127             ;si code inferieur  127
          jbe  no_conv            ;pas de conversion

          sub  bl,128             ;calcul de l'indice du tableau
          mov  al,es:[bx+(offset codetab)]  ;code converti dans al
          mov  ds:[bp+si-1],al    ;rcriture dans buffer

no_conv : dec  si                 ;accs caractre prcdent dans budder
          jnz  loop1              ;si si<>0, on boucle

          pop  si                 ;Retirer registres sauvegards
          pop  bp
          pop  di
          pop  es
          pop  dx
          pop  cx
          pop  bx
          pop  ax
          popf

          jmp  aint               ;Vers l'ancienne routine imprimante

          ;traitement de l'interruption par fonction 5 du DOS

dos_imp :
          cmp  dl,127             ;si code inferieur  127
          jbe  aint               ;pas de conversion

          pushf                   ;Tous les registres modifis par la
          push ax                 ;suite doivent tre sauvegards
          push bx
          push si
          push ds

          push cs                 ;Ranger CS sur la pile
          pop  ds                 ;Retirer de la pile pour DS

          mov  bl,dl              ;transfert code caractre dans bl
          sub  bl,128             ;soustraire 128 pour obtenir index table
          xor  bh,bh              ;effacer octet de poids fort
          mov  dl,[bx+(offset codetab)] ;nouveau caractre dans dl

          pop  ds                 ;Retirer registres sauvegards
          pop  si
          pop  bx
          pop  ax
          popf

aint:     jmp  cs:[ancint]        ;Vers l'ancienne routine imprimante

newpri    endp

instend   equ  this byte          ;Jusqu' cette cellule de mmoire
                                  ;tout doit rester rsident

;== Donnes (peuvent tre effaces par le DOS) =========================

installm  db   13,10,"TJR8 est install.",13,10,"$"
already   db   13,10,"TJR8 est dj install.",13,10,"$"
to_des    db   "Pour le dsactiver :  TJR8 U",13,10,"$"

elimine   db   "TJR8 est dsactiv",13,10,"$"

;== Programme (peut tre effac par le DOS) ============================
;-- Routine de lancement et initialisation -----------------------------

prcoini   label near

          mov  si,128             ;place sur dbut paramtre dans PSP
          cmp  byte ptr [si],0    ;Y a t-il des paramtres ?
          je   install            ;non, on installe
          inc  si                 ;dcalage de "si" sur le premier paramtre
          inc  si
          cmp  byte ptr [si],"U"  ;dsinstalation demande ?
          jne  install            ;non on va l'installer

          mov  ax,3521h           ;Lire contenu vecteur d'interruption 21h
          int  21h                ;Appeler fonction DOS
          cmp  word ptr es:[bx+2],"JT" ;Tester si programme TJR8
          jne  not_inst           ;Pas de TJRR8 install --> not_inst

          ;-- Dsactivation de TJR8 ---------------------------------------

          mov  dx,es:ofsancint    ;Adresse d'offset de l'interruption 21h
          mov  ax,es:segancint    ;Adresse de segment de l'interruption 21h
          mov  ds,ax              ;dans DS
          mov  ax,2521h           ;Replacer contenu vecteur d'interruption 21h
          int  21h                ;sur ancienne routine

          mov  bx,es              ;Ranger adresse de segment du programme
          mov  es,es:[2Ch]        ;Retirer du PSP adr. seg. de l'environnement
          mov  ah,49h             ;Librer  nouveau mmoire 
          int  21h                ;d'ancien environnent
          mov  es,bx              ;Librer  nouveau la mmoire
          mov  ah,49h             ;de l'ancienne TJR8
          int  21h                ; travers la fonction 49h du DOS

          push cs                 ;Sauver CS sur la pile
          pop  ds                 ;Ramener dans DS

not_inst: mov  dx,offset elimine  ;Message : programme limin
          mov  ah,9               ;Numro de fonction pour Ecrire chane
          int  21h                ;Appeler fonction DOS

          mov  ax,4C00h           ;Terminer programme correctement
          int  21h                ;Appeler fonction pour terminer progr.

          ;-- Installation de TJR8 -------------------------------------

install   label near

          mov  ax,3521h           ;Lire contenu vecteur d'interruption 21h
          int  21h                ;Appeler fonction DOS
          cmp  word ptr es:[bx+2],"JT" ;Tester si programme TJR8
          je   already_inst       ;TJRR8 dj install --> already_inst

          mov  ax,3521h           ;Lire contenu du vecteur d'interruption 21h
          int  21h                ;Appeler fonction DOS
          mov  segancint,es       ;Ranger adresses de segment et d'offset
          mov  ofsancint,bx       ;Ranger vecteur d'interruption 21h

          mov  dx,offset newpri   ;Adresse d'offset nouvelle routine d'interr.
          mov  ax,2521h           ;Contenu du vecteur d'interruption 21h
          int  21h                ;sur routine utilisateur
          mov  dx,offset installm ;Message : programme install
          mov  ah,9               ;Numro de fonction pour Sortir chane
          int  21h                ;Appeler fonction DOS
          mov  dx,offset to_des   ;Message : comment dsinstaller
          mov  ah,9               ;Numro de fonction pour Sortir chane
          int  21h                ;Appeler fonction DOS

          ;-- Seuls le PSP, la nouvelle routine d'interruption et les
          ;-- donnes correspondantes doivent rester rsidentes. -------

          mov  dx,offset instend  ;Calculer nombre de paragraphes (units de 16
          mov  cl,4               ;octets) dont doit disposer le programme
          shr  dx,cl
          inc  dx
          mov  ax,3100h           ;Terminer programme par code de fin 0 (o.k)
          int  21h                ;mais rester rsident

          ;-- TJR8 est dj install : on affiche message et on sort -------

already_inst:
          mov  dx,offset already  ;Message : programme dj install
          mov  ah,9               ;Numro de fonction pour Sortir chane
          int  21h                ;Appeler fonction DOS
          mov  dx,offset to_des   ;Message : comment dsinstaller
          mov  ah,9               ;Numro de fonction pour Sortir chane
          int  21h                ;Appeler fonction DOS

          mov  ax,4C00h           ;Terminer programme correctement
          int  21h                ;Appeler fonction pour terminer progr.

;== Fin ================================================================

code      ends                    ;Fin du segment de CODE
          end  start
