;*****************************************************************************
;**                                T J P S                                  **
;**              Impression d'cran sur ThinkJet Par HP-LINK                **
;**                                                                         **
;**    Cration le 05/08/92               Auteur : Jacques Belin            **
;**                                   (d'aprs PRCO de Michael Tischer)     **
;**    Dernire modif.: 05/08/92                                            **
;**                                                                         **
;*****************************************************************************

;== Ici commence le programme vritable ================================

code      segment para 'CODE'     ;Dfinition du segment de CODE

          org  100h

          assume cs:code, ds:code, es:code, ss:code

start:    jmp   init_pr           ;La premire instruction excute

;== Donnes (restent en mmoire) ======================================

ancint    equ  this dword         ;Ancien vecteur d'interruption 05h
ofsancint dw   (?)                ;Adresse d'offset vecteur d'interruption 05h
segancint dw   (?)                ;Adresse de segment vecteur d'interr. 05h
Filler    db   (?)                ;Non utilise mais doit tre prsente ici
reinit    db   13,10              ;chaine fin impression (reinit+normal)
normal    db   27,"&k0S"          ;slection mode 80 colonnes sur ThinkJet
expanded  db   27,"&k1S"          ;slection mode 40 colonnes sur ThinkJet
comprsd   db   27,"&k2S"          ;slection mode 142 colonnes sur ThinkJet
buffchar  db   150 DUP (?)        ;buffer des caractres  imprimer


;== Voici la nouvelle interruption imprimante (reste en mmoire) =======

newpri    proc far
          jmp  short newpri_1

          db   "PS"               ;Identification du programme

newpri_1: pushf                   ;sauvegarde des registres
          push ax
          push bx
          push cx
          push dx
          push bp
          push ds
          push si
          push es
          push di

          mov  ax,0050h            ;test si print screen dj en cours
          mov  ds,ax
          xor  si,si
          cmp  byte ptr [si],1
          jne  skip                ;non, on continue le programme
          jmp  aint                ;oui, on sort du programme
skip:     mov  byte ptr [si],1     ;non, on arme le flag

          sti                      ;on autorise les interruptions

          mov  ax,0040h            ;segment 40 contient des infos sur config
          mov  ds,ax
          mov  si,63h
          mov  bx,[si]             ;lecture adresse du port vido
          cmp  bx,03B4h            ;adresse port = 3b4 ?
          jne  add_b8
          mov  ax,0B000h           ;oui, addresse ram vido = B000
          jmp  set_vadd
add_b8:   mov  ax,0B800h           ;non, addresse ram vido = B800
set_vadd: mov  es,ax               ;stockage segment adresse vido dans ES
          mov  si,4Eh
          mov  di,[si]             ;stockage offset sur page active

          mov  si,4Ah              ;stockage du nombre de colonnes dans
          mov  bx,[si]             ;bl

          mov  si,84h              ;stockage du nombre de lignes
          mov  bh,[si]             ;dans bh
          inc  bh
                                   ;BX contient donc : nb_lignes|nb_colonnes
                                   ;                        BH       BL
          mov  bp,bx               ;sauvegarde bx dans bp

          mov  ax,cs               ;DS = CS
          mov  ds,ax
          cmp  bl,40               ;plus de 40 colonnes affiches ?
          ja   m80cols             ;oui, on va plus bas
          mov  dx,offset expanded  ;oui, on charge adresse chaine 'expanded'
          jmp  storemod
m80cols:  cmp  bl,80               ;plus de 80 colonnes affiches ?
          ja   m132cols            ;oui, on va plus bas
          mov  dx,offset normal    ;non, on charge adresse de chaine 'normal'
          jmp  storemod
m132cols: mov  dx,offset comprsd   ;on charge adresse de chaine 'comprsd'
storemod: mov  ah,40h              ;fonction d'ecriture sur handle
          mov  bx,4                ;ecriture sur handle numro 4 (stdprn)
          mov  cx,5                ;5 octets  ecrire
          int  21h                 ;appel au Dos pour configuration ThinkJet


loop_lin: mov  ax,bp               ;rcupration du nombre de colonnes dans al
          mov  si,offset buffchar  ;stockage adresse buffer dans si
loop_col: mov  dl,es:[di]          ;lire caractre
          cmp  dl,20h              ;code caractre superieur  32 ?
          jae  legal               ;oui, on saute
          mov  dl,'.'              ;transformation du caractre
legal:    mov  [si],dl             ;charger caractre dans buffer
          inc  si                  ;prochain caractre dans buffer
          inc  di                  ;prochain caractre dans mmoire vido
          inc  di
          dec  al                  ;dcrmentation indice colonne
          jnz  loop_col            ;si diffrent de zro, on boucle
          mov  byte ptr [si],13    ;stockage d'un CR dans buffer
          inc  si                  ;prochain caractre dans buffer
          mov  byte ptr [si],10    ;stockage d'un LF dans buffer
          mov  ah,40h              ;fonction d'ecriture dans Handle
          mov  bx,4                ;numro du handle (strprn)
          mov  cx,bp               ;rcupration du nombre de colonnes
          xor  ch,ch               ;mettre ch  0
          add  cl,2                ;ajouter les 2 caractres du CR/LF
          mov  dx,offset buffchar  ;adresse du buffer en DS:DX (DS est OK)
          int  21h                 ;ecriture sur handle
          mov  cx,bp               ;dcrmentation indice ligne
          dec  ch                  
          mov  bp,cx               ;on remet vite bp en place
          jnz  loop_lin            ;si "dec ch" ->diffrent de zro, on boucle

          mov  dx,offset reinit    ;on charge adresse de chaine 'reinit'
          mov  ah,40h              ;fonction d'ecriture sur handle
          mov  bx,4                ;ecriture sur handle numro 4 (stdprn)
          mov  cx,7                ;7 octets  ecrire (reinit+normal)
          int  21h                 ;appel au Dos pour reinit ThinkJet


fin:      mov  ax,0050h            ;effacement du flag de print screen
          mov  ds,ax
          xor  si,si
          mov  byte ptr [si],0

aint:     pop  di                 ;Retirer registres sauvegards
          pop  es
          pop  si
          pop  ds
          pop  bp
          pop  dx
          pop  cx
          pop  bx
          pop  ax
          popf

          iret                    ;fin de la routine d'interruption

newpri    endp

instend   equ  this byte          ;Jusqu' cette cellule de mmoire
                                  ;tout doit rester rsident

;== Donnes (peuvent tre effaces par le DOS) =========================

installm  db   13,10,"TJPS est install.",13,10,"$"
already   db   13,10,"TJPS est dj install.",13,10,"$"
to_des    db   "Pour le dsactiver :  TJPS U",13,10,"$"

elimine   db   "TJPS est dsactiv",13,10,"$"

;== Programme (peut tre effac par le DOS) ============================
;-- Routine de lancement et initialisation -----------------------------

init_pr   label near

          mov  si,128             ;place sur dbut paramtre dans PSP
          cmp  byte ptr [si],0    ;Y a t-il des paramtres ?
          je   install            ;non, on installe
          inc  si                 ;dcalage de "si" sur le premier paramtre
          inc  si
          cmp  byte ptr [si],"U"  ;dsinstalation demande ?
          jne  install            ;non on va l'installer

          mov  ax,3505h           ;Lire contenu vecteur d'interruption 05h
          int  21h                ;Appeler fonction DOS
          cmp  word ptr es:[bx+2],"SP" ;Tester si programme TJPS
          jne  not_inst           ;Pas de TJRR8 install --> not_inst

          ;-- Dsactivation de TJPS ---------------------------------------

          mov  dx,es:ofsancint    ;Adresse d'offset de l'interruption 05h
          mov  ax,es:segancint    ;Adresse de segment de l'interruption 05h
          mov  ds,ax              ;dans DS
          mov  ax,2505h           ;Replacer contenu vecteur d'interruption 05h
          int  21h                ;sur ancienne routine

          mov  bx,es              ;Ranger adresse de segment du programme
          mov  es,es:[2Ch]        ;Retirer du PSP adr. seg. de l'environnement
          mov  ah,49h             ;Librer  nouveau mmoire 
          int  21h                ;d'ancien environnent
          mov  es,bx              ;Librer  nouveau la mmoire
          mov  ah,49h             ;de l'ancienne TJPS
          int  21h                ; travers la fonction 49h du DOS

          push cs                 ;Sauver CS sur la pile
          pop  ds                 ;Ramener dans DS

not_inst: mov  dx,offset elimine  ;Message : programme limin
          mov  ah,9               ;Numro de fonction pour Ecrire chane
          int  21h                ;Appeler fonction DOS

          mov  ax,4C00h           ;Terminer programme correctement
          int  21h                ;Appeler fonction pour terminer progr.

          ;-- Installation de TJPS -------------------------------------

install   label near

          mov  ax,3505h           ;Lire contenu vecteur d'interruption 05h
          int  21h                ;Appeler fonction DOS
          cmp  word ptr es:[bx+2],"SP" ;Tester si programme TJPS
          je   already_inst       ;TJRR8 dj install --> already_inst

          mov  segancint,es       ;Ranger adresses de segment et d'offset
          mov  ofsancint,bx       ;Ranger vecteur d'interruption 05h

          mov  dx,offset newpri   ;Adresse d'offset nouvelle routine d'interr.
          mov  ax,2505h           ;Contenu du vecteur d'interruption 05h
          int  21h                ;sur routine utilisateur
          mov  dx,offset installm ;Message : programme install
          mov  ah,9               ;Numro de fonction pour Sortir chane
          int  21h                ;Appeler fonction DOS
          mov  dx,offset to_des   ;Message : comment dsinstaller
          mov  ah,9               ;Numro de fonction pour Sortir chane
          int  21h                ;Appeler fonction DOS

          ;-- Seuls le PSP, la nouvelle routine d'interruption et les
          ;-- donnes correspondantes doivent rester rsidentes. -------

          mov  dx,offset instend  ;Calculer nombre de paragraphes (units de 16
          mov  cl,4               ;octets) dont doit disposer le programme
          shr  dx,cl
          inc  dx
          mov  ax,3100h           ;Terminer programme par code de fin 0 (o.k)
          int  21h                ;mais rester rsident

          ;-- TJPS est dj install : on affiche message et on sort -------

already_inst:
          mov  dx,offset already  ;Message : programme dj install
          mov  ah,9               ;Numro de fonction pour Sortir chane
          int  21h                ;Appeler fonction DOS
          mov  dx,offset to_des   ;Message : comment dsinstaller
          mov  ah,9               ;Numro de fonction pour Sortir chane
          int  21h                ;Appeler fonction DOS

          mov  ax,4C00h           ;Terminer programme correctement
          int  21h                ;Appeler fonction pour terminer progr.

;== Fin ================================================================

code      ends                    ;Fin du segment de CODE
          end  start
