;*****************************************************************************;
;*****************************************************************************;
;**                                DU.ASM                                   **;
;**                  Affichage de l'encombrement des rpertoires            **;
;**                                                                         **;
;**   Dernire modification : 28/05/93        Auteur : Jaques Belin         **;
;**       Cration                                                          **;
;**                                                                         **;
;*****************************************************************************;
;*****************************************************************************;
         DOSSEG
code     segment para 'CODE'
         assume cs:code,ds:code
         ORG    100h
start:   jmp    main                    ; premire inst. excute

PATH_SIZ EQU    80                      ; taille maxi d'un chemin
DTA_SIZE EQU    48                      ; taille de la DTA

FA_ARCH  EQU    1                       ; codes d'attributs des fichiers
FA_HIDD  EQU    2
FA_SYST  EQU    4
FA_VOL   EQU    8
FA_DIR   EQU    16

         INCLUDE getopt.inc             ; routine d'analyse des options

optstr   DB     "51248",0               ; chaine des options
errflg   DB     0                       ; flag d'erreur

cl_size  DW     0                       ; taille d'un cluster en octets
tot_size DW     0                       ; taille totale (en clusters)
nb_dirs  DW     0                       ; nombre de directories sur disque

drive    DB     0                       ; code du disque (0=A, 1=B...)
cur_path DB     PATH_SIZ dup (?)        ; directory de base  

                                        ; Messages d'erreur
bad_disk DB     "Bad drive specified",13,10  ; (pas de fin de chaine ($))
usage    DB     "usage :  du  [ -5 | -1 | -2 | -4 | -8 ]  [ [disk:] path ]",13,10,13,10,"$"


dcl_size DB     "   Cluster size = "
dcl_si_2 DB     "xxxxx",13,10,"$"

di_size  DB     13,10
di_siz_2 DB     "xxxxxxxxxx bytes in "
di_siz_3 DB     PATH_SIZ dup (?)

total    DB     13,10,13,10,"   Total : "
total_2  DB     "xxxxxxxxxx bytes",13,10,"$"

no_path  DB     ".",0
back_sl  DB     "\",0
wilds    DB     "\*.*",0


main:    mov    bx,cs                   
         mov    ds,bx                  ; on assure DS=CS    
         mov    es,bx                  ; on assure ES=CS    

         mov    ah,4Ah                 ; on rjuste taille du bloc programmee
         mov    bx,4096/16
         int    21h                    
         mov    sp,4096                ; on replace le pointeur de pile

         call   parse                  ; parsing dans argv[]

         xor    cl,cl
optloop: call   getopt                 ; analyse des options
         cmp    al,EOF                 ; fin d'analyse ?
         je     main_2                 ; oui, on passe  la suite du prgm
         cmp    al,"?"                 ; si erreur, on arme le flag
         je     opterr
         mov    cl,al                  ; sinon on stocke le code dans cl
         jmp    nextopt
opterr:  inc    byte ptr [errflg]      
nextopt: jmp    optloop                ; on boucle tant qu'on a pas EOF
         ;-------------

main_2:  cmp    byte ptr [errflg],0    ; si une erreur a t dtecte...
         je     main_3
         mov    dx,OFFSET usage        ; ...on affiche le message d'erreur...
         mov    ah,09h
         int    21h
         jmp    exit                   ; ...et on sort.
         ;----------

main_3:  cmp    cl,0                   ; si une option a t spcifie...
         je     main_4
         mov    al,cl                  ; on recherche sa position dans "51248"
         mov    dx,OFFSET optstr       ;  (la position dans la chaine indique
         call   strchr                 ;  en '2^p' le nbre de secteurs/cluster
         sub    dx,OFFSET optstr
         mov    cl,dl                  ; on effectue un dcalage sur ax...
         mov    ax,1                   ;  suivant la position dans la chaine
         shl    ax,cl                  ;  afin d'avoir le nombre de sect/clust
         mov    cx,512                 ; et on multiplie par 512 
         mul    cx
         mov    [cl_size],ax           ; on n'a plus qu'a stocker

main_4:  call   getdisk                ; acquisition du drive courant
         mov    [drive],al             ; drive = disque courant
         mov    ax,[optind]            ; argc == optind ? (pas de path ?)
         cmp    ax,[argc]
         jne    main_5                 ; non, on rcupre le path
         push   es                     ; sauvegarde segment PSP
         push   ds                     ; copie de "." dans cur_path
         pop    es
         mov    di,OFFSET no_path
         mov    si,OFFSET cur_path
         call   strcpy                 
         pop    es                     ; rcupration segment PSP
         jmp    main_8
         ;------------

main_5:  mov    bx,[optind]            ; bx = optind
         shl    bx,1
         mov    si,OFFSET argv         ; si = argv
         mov    di,ds:[si+bx]          ; di ^ argv[optind]
         mov    al,es:[di+1]           ; al = 2me caractre du paramtre
         cmp    al,":"                 ; est-ce un descripteur de disque ?
         jne    main_7                 ; non -> on prendra le disque courant
         mov    al,es:[di]             ; al = 1er caractre du paramtre
         cmp    al,"a"                 
         jna    main_6
         cmp    al,"z"
         ja     main_6
         sub    al,32                  ; normalisation en majuscules
main_6:  sub    al,"A"                 ; conversion en numro de disque
         mov    [drive],al             ; nouveau disque
main_7:  mov    si,OFFSET cur_path     
         call   strcpy                 ; copie argv[optind] dans cur_path
                                       ; (ES:DI dj dfini plus haut)
         mov    dx,si
         call   strlen
         mov    bx,cx
         cmp    byte ptr [si+bx-1],"\" ; dernier caractre de cur_path="\" ?
         jne    main_8                 ; non, on continue
         mov    byte ptr [si+bx-1],0   ; oui, on l'efface

main_8:  mov    ax,[cl_size]
         cmp    ax,0                   ; un cl_size a t-il t spcifi ?
         jne    main_A                 ; oui, on continue
         mov    ah,36h                 ; int 21/36h = informations disque
         mov    dl,[drive]
         inc    dl
         int    21h                    ; acquisition des infos disque
         cmp    ax,0ffffh
         jne    main_9                 ; si ax diffrent de FFFF, disque ok
         mov    dx,OFFSET bad_disk     ; sinon ->erreur...
         mov    ah,09h
         int    21h                    
         jmp    exit                   ; ...et on sort du programme.
         ;----------

main_9:  mul    cx                     ; AX=AX*CX : taille cluster en octets
         mov    [cl_size],ax           ; drive = taille cluster
main_A:  xor    dx,dx                  ; conversion taille cluster en chaine
         mov    si,OFFSET dcl_si_2
         mov    bx,5
         call   ltoa                   
         mov    dx,OFFSET dcl_size     ; affichage taille cluster
         mov    ah,09h
         int    21h                    

         push   ds                     ; on fait pointer ES:DI sur cur_path
         pop    es
         mov    di,offset cur_path
         call   d_usage                ; APPEL A LA ROUTINE PRINCIPALE

         cmp    word ptr [nb_dirs],1   ; si 1 seul directory trait, on sort
         jna    exit                   

         mov    ax,[tot_size]
         mul    [cl_size]              ; DX:AX = AX*[cl_size] : taille totale
         mov    si,OFFSET total_2      ; conversion taille en chaine
         mov    bx,10
         call   ltoa                   
         mov    dx,OFFSET total        ; affichage taille totale 
         mov    ah,09h
         int    21h                    

exit:    mov    ah,4ch                 ; retour au DOS
         int    21h
         

;****************************************************
; D_USAGE : affiche rcursivement l'encombrement de
;           chaque directory
; entres : ES:DI adresse du directory courant 
;           (termin par caractre 0)  
;****************************************************
dir_size DW     (?)                    ; encombrement du directory, en clusters

d_usage  PROC   NEAR
         push   ax
         push   bx
         push   cx
         push   dx
         push   bp
         push   es
         push   di
         push   ds
         push   si

         call   getdta                 ; sauvegarde de la DTA dans la pile
         push   ax

         mov    word ptr cs:[dir_size],0 ; initialisation taille courante a 0
         inc    word ptr cs:[nb_dirs]  ; inc. nombre de directory traits

         mov    ah,48h
         mov    bx,((DTA_SIZE+PATH_SIZ)/16)+1 ; taille en paragraphes
         int    21h                    ; allocation d'un bloc de mmoire
         push   ax

         push   di                     ; sauvegarde paramtre d'entre
         push   es
         mov    bp,sp                  ; on va se servir de BP comme indice
                                       ; pour les accs dans la pile

         ; partir d'ici on a dans la pile :
         ; bp    =  ES niveau prcdent
         ; bp+2  =  DI niveau prcdent
         ; BP+4  =  segment du buffer courant
         ; BP+6  =  DTA prcdente
         ;   .
         ;   .
         
         xor    bx,bx                  ; fait pointer nouvelle DTA sur buffer
         call   setdta                 

         mov    ds,ax                  ;copie path courant aprs DTA ds buffer
         mov    si,DTA_SIZE
         call   strcpy                 

         push   cs                     ; ES=CS
         pop    es                     ; ajoute "\*.*" en fin de curpath
         mov    di,OFFSET wilds
         call   strcat                 

                                       ; RECHERCHE DES FICHIERS DU REPERTOIRE
         mov    ah,4Eh                 ; cherche premier fichier du rpertoire
         mov    dx,si
         mov    cx,FA_HIDD+FA_SYST     ; attributs de recherche
         int    21h                    

d_usa_1: jc     d_usa_3                ; si carry -> recherche termine
         mov    ax,ds:[1Ah]            ; DS:[1A,1C] = taille fichier en octets
         mov    dx,ds:[1Ch]
         div    cs:[cl_size]           ; taille du fichier en clusters
         cmp    dx,0                   ; +1 si cluster incomplet
         je     d_usa_2
         inc    ax                     
d_usa_2: add    cs:[dir_size],ax       ; calcul encombrement du directory
         mov    ah,4Fh                 ; cherche fichier suivant
         int    21h                    
         jmp    d_usa_1                ; et on boucle
         ;-------------

d_usa_3: mov    ax,cs:[dir_size]       ; rcupration encombrement directory
         add    cs:[tot_size],ax       ; on en profite pour le grand total
         mul    word ptr cs:[cl_size]  ; encombrement directory en octets
         mov    bx,10                  ; conversion taille en chaine
         push   cs
         pop    ds
         mov    si,OFFSET di_siz_2
         call   ltoa                   

         mov    ax,ss:[bp]             ; ES:DI = paramtre d'entre
         mov    es,ax
         mov    di,ss:[bp+2]           
         mov    si,OFFSET di_siz_3
         call   strcpy                 ; copie nom directory en fin de chaine

         mov    bx,1                   ; affichage du texte dans 'stdout'
         mov    dx,offset di_size
         call   fprintf                
                                       ; RECHERCHE DANS LES SOUS REPERTOIRES
         mov    dx,ss:[bp+4]           ; on reprend cur_path comme base
         mov    ds,dx
         mov    dx,DTA_SIZE            ; cherche premier fichier
         mov    ah,4Eh                 
         mov    cx,FA_DIR
         int    21h                    

d_usa_4: jc     d_usa_9                ; si carry -> termin
         mov    al,ds:[15h]            ; si attribut fichier # directory...
         and    al,FA_DIR               
         jz     d_usa_5
         cmp    byte ptr ds:[1Eh],"."  ; ... et nom directory = "." ou ".."
         je     d_usa_5                ; ...on passe  l'entre suivante

         mov    ax,ss:[bp]             ; ES:DI = paramtre d'entre (rcursif)
         mov    es,ax
         mov    di,ss:[bp+2]           
         mov    si,DTA_SIZE            ; copie paramtre dans buffer
         call   strcpy                 

         push   cs                     ; on ajoute "\" au paramtre
         pop    es
         mov    di,OFFSET back_sl
         call   strcat

         push   ds                     ; on ajoute le nom de l'entre
         pop    es
         mov    di,1Eh
         call   strcat

         mov    di,si                  ; ES:DI = nouveau paramtre
         call   d_usage                ; appel rcursif

d_usa_5: mov    ah,4Fh                 ; cherche fichier suivant
         int    21h                    
         jmp    d_usa_4                ; et on boucle
         ;-------------

d_usa_9: pop    ax                     ; on depile les donnes inutiles
         pop    ax                     

         pop    es                     ; libration du buffer
         mov    ah,49h
         int    21h                    

         pop    ax                     ; reinitialisation de l'ancienne DTA
         xor    bx,bx
         call   setdta                 

d_usa_e: pop    si
         pop    ds
         pop    di
         pop    es
         pop    bp
         pop    dx
         pop    cx
         pop    bx
         pop    ax
         ret
d_usage  ENDP


;****************************************************
; STRCAT  : place une chaine  la fin d'une autre        
; entres : ES:DI  adresse de la chaine source
;           (termine par caractre 0)  
;           DS:SI  adresse de la chaine destination
;****************************************************
strcat   PROC   NEAR
         push   cx
         push   dx
         push   si
      
         mov    dx,si                  ; calcul longueur de chaine
         call   strlen
         add    si,cx                  ; on copie aprs le dernier caractre
         call   strcpy
            
strca_1: pop    si
         pop    dx
         pop    cx
         ret
strcat   ENDP


;****************************************************
; GETDISK : Donne le disque courant                      
; entres : Aucune                              
; sortie  : AL = disque (0=A 1=B 2=C..)  
;****************************************************
getdisk  PROC   NEAR
         push   bx

         push   ax                     ; sauvegarde de AX
         mov    ah,19h                 ; lecture numro du disque
         int    21h
         pop    bx                     ; on fait en sorte que AH ne soit pas
         mov    bl,al                  ;  modifi, par la fonction
         mov    ax,bx

         pop    bx
         ret
getdisk  ENDP


;****************************************************
; GETDTA  : Donne l'adresse de la DTA
; entres : Aucune                              
; sortie  : AX:BX = segment DTA
;****************************************************
getdta   PROC   NEAR
         push   es

         mov    ah,2Fh                 ;  lecture adresse DTA
         int    21h
         mov    ax,es

         pop    es
         ret
getdta   ENDP


;****************************************************
; SETDTA  : Positionne l'adresse de la DTA                    
; entres : AX:BX = adresse DTA                   
; sortie  : aucune             
;****************************************************
setdta   PROC   NEAR
         push   ax
         push   bx
         push   dx
         push   ds

         mov    ds,ax                  ; on positionn les paramtres
         mov    dx,bx
         mov    ah,1Ah                 ; selection de la DTA
         int    21h

         pop    ds
         pop    dx
         pop    bx
         pop    ax
         ret
setdta   ENDP

;****************************************************
; FPRINTF : affiche une chaine de caractres dans 
;           le flux BX       
; entres : DS:DX = Chaine
;           BX = handle                        
; sortie  : Aucune
;****************************************************
fprintf  PROC   NEAR
         push   ax
         push   cx

         call   strlen                 ; calcul de la longueur de la chaine
         mov    ah,40h                 ; affichage
         int    21h

         pop    cx
         pop    ax
         ret
fprintf  ENDP


;================================================
; LTOA : Conversion d'un entier long en chaine
;        justifie  droite
;        Pas de code de fin de chaine ('\0')
; Entres: DX:AX = nombre  convertir
;          BX = nombre de digits total
;          DS:SI = Adresse du dbut de chaine
;================================================
ltoa     PROC    NEAR
         push    bx
         push    cx
         push    di
         push    si
         push    bp

         push    dx                    ; on sauve le paramtre dans la pile
         push    ax                    ;  (pour simplifier les accs)
         mov     bp,sp

         add     si,bx                 ; calcul position du dernier caractre 
         dec     si                    ;  de la chaine (digit poids faible)

         mov     cx,10                 ; diviseur (base)

ltoa_1:  mov     ax,[bp+2]             ; on rcupre le mot de poids fort
         sub     dx,dx                 ; la division ne se fait que sur AX
         div     cx                    ; division, le reste est en DX
         mov     [bp+2],ax             ; on sauve le quotient 

         mov     ax,[bp]               ; mot de poids faible
         div     cx                    ; division DX:AX/CX, le digit est en DX 
         mov     [bp],ax               ; sauve quotient 

         add     dl,30h                ; conversion du digit en ASCII
         mov     [si],dl               ; criture dans chaine
         dec     si
         dec     bx
         
         cmp     word ptr [bp],0       ; teste si fini
         jne     ltoa_1                ; sinon, on boucle
         cmp     word ptr [bp+2],0
         jne     ltoa_1

         mov     cx,bx                 ; on remplit les digits non utiliss
ltoa_2:  mov     byte ptr [si]," "     ; par des espaces
         dec     si
         loop    ltoa_2
     
         pop     ax                    
         pop     dx
         pop     bp
         pop     si
         pop     di
         pop     cx
         pop     bx
         ret
ltoa     ENDP

Code     ends
         END    start                  ; fin du programme
