;*****************************************************************************;
;*****************************************************************************;
;**                               GETOPT.INC                                **;
;**                 Analyse des options de la ligne de commande             **;
;**                                                                         **;
;**   Dernire modification : 28/05/93        Auteur : Jaques Belin         **;
;**       Cration                                                          **;
;**                                                                         **;
;**   Note : Module pour programme assembleur, non prvu pour fonctionner   **;
;**          en tant que fonction C                                         **;
;**          Inclue les fonctions strcpy, strlen et strchr                  **;
;*****************************************************************************;
;*****************************************************************************;
EOF      EQU    255
NULL     EQU    0ffffh

         INCLUDE parse.inc

; variables globales
optarg   DW     (?)                    ; ptr sur argument optionnel (dans psp)
optind   DW     1                      ; indice sur paramtre
SW       DB     "-"                    ; caractre d'option

;variables locales
_ptopt   DW     (?)                    ; pointeur sur option
_retour  DB     "?"                    ; code retourn
_lenarg  DW     (?)                    ; longueur argument

;****************************************************
; GETOPT  : analyse des options de la ligne de commande
; retour  AL : code de l'option
; Note : La fonction "parse" doit avoir t appele prcdement
;        Une variable 'optstr' contenant les options
;         doit tre dfinie dans le programme principal
;****************************************************
getopt   PROC   NEAR
         push   bx
         push   cx
         push   dx
         push   es
         push   di
         push   ds
         push   si

         mov    word ptr [optarg],NULL

         mov    ax,[argc]              ; si fin de la ligne de commande
         cmp    ax,[optind]
         je     getop_E                ; (getop_E : saut intrmediaire)

getop_1: mov    ax,[psp]               ; ES = segment du PSP
         mov    es,ax
         mov    si,offset argv         ; calcul de ds:si pour argv[optind]
         mov    bx,[optind]
         shl    bx,1
         mov    di,ds:[si+bx]          ; ES:DI = adresse du paramtre
         mov    al,es:[di]             ; al = premier caractre du paramtre        
         cmp    al,[SW]                ; *argv[optind] = SW ?
         jne    getop_E                ; non, -> getop_5 via getop_E
                                       ; (pour viter un saut trop long)
         push   ds                     ; sauvegarde ds
         push   es                     ; ds = es
         pop    ds
         mov    dx,di
         call   strlen                 ; _lenarg = longueur chaine
         pop    ds                     ; rcupration ds
         mov    word ptr [_lenarg],cx
         mov    al,byte ptr es:[di+1]     
         mov    [_retour],al
         cmp    al,[SW]                ; cas option '--' ?
         jne    getop_2                ; non, on continue
         inc    word ptr [optind]      ; optind++
getop_E: jmp    getop_5                ; -> fin d'analyse
         ;-------------

getop_2: mov    dx,offset optstr
         call   strchr                 ; recherche option dans optstring
         cmp    dx,NULL                ; si option non trouve
         je     getop_6                ; sortie avec erreur
         mov    bx,dx
         cmp    byte ptr ds:[bx+1],":" ; est ce une option  paramtre ?
         jne    getop_4                ; non -> getop_4
         cmp    word ptr [_lenarg],2   ; longueur argument = 2 ?
         jne    getop_3                ; non ->getop_3
         inc    word ptr [optind]      ; accs  l'argument suivant
         mov    bx,[optind]
         shl    bx,1
         mov    di,ds:[si+bx]
         mov    [optarg],di            ; acquisition adresse paramtre
         mov    cx,[optind]            ; si optind >= argc...
         cmp    cx,[argc]
         jae    getop_6                ; ..alors erreur et sortie   
         cmp    byte ptr es:[di],"-"   ; ..ou *optarg = "-"...
         je     getop_6                ; ..alors erreur et sortie
         jmp    getop_7
         ;-------------

getop_3: add    di,2
         mov    [optarg],di            ; acquisition adresse paramtre
         jmp    getop_7                
getop_4: cmp    word ptr [_lenarg],2   ; si options non groupes ("-abc")..
         je     getop_7                ; ..on sort
                                       ; si options groupes...
         mov    bx,[optind]            ; on remplace "-abc" par "-bc"
         shl    bx,1
         inc    word ptr ds:[si+bx]    ; ..en dcalant l'adresse du paramtre
         mov    byte ptr es:[di+1],"-" ; ..et en remplacant "a" par "-"
         jmp    getop_8
         ;-------------

getop_5: mov    al,EOF
         jmp    getop_9
         ;-------------

getop_6: mov    byte ptr [_retour],"?" ; retour code d'erreur
getop_7: inc    word ptr [optind]      ; on incrmente optind
getop_8: mov    al,[_retour]
getop_9: pop    si
         pop    ds
         pop    di
         pop    es
         pop    dx
         pop    cx
         pop    bx
         ret
getopt   ENDP

;****************************************************
; STRCHR  : cherche un caractre dans une chaine
; entres : AL caractre  trouver
;           DS:DX  adresse de la chaine de rfrence
; retour    si trouv : DS:DX = pointeur sur caractre
;                               dans chaine
;           si non trouv : DX = NULL
;****************************************************
strchr   PROC   NEAR
         push   bx
         
         mov    bx,dx
strch_1: cmp    byte ptr ds:[bx],0     ; fin de la chaine ?
         je     strch_2                ; oui -> erreur
         cmp    ds:[bx],al             ; caractre trouv ?
         je     strch_3                ; oui -> fin
         inc    bx                     ; non, on pointe sur caractre suivant
         jmp    strch_1                ; on boucle...
         ;-------------

strch_2: mov    bx,NULL

strch_3: mov    dx,bx
         pop    bx
         ret
strchr   ENDP

;****************************************************
; STRLEN  : calcule la longueur d'une chaine
; entres : DS:DX adresse de la chaine
; retour  : CX = longueur                                
;****************************************************
strlen   PROC   NEAR
         push   bx

         xor    cx,cx
         mov    bx,dx
strle_1: cmp    byte ptr ds:[bx],0     ; fin de la chaine ?
         je     strle_2                ; oui -> fin de routine
         inc    cx                     ; incrmentation taille
         inc    bx                     ; on pointe sur caractre suivant
         jmp    strle_1                ; on boucle...
         ;-------------
         
strle_2: pop    bx
         ret
strlen   ENDP


;****************************************************
; STRCPY  : copie de chaine                              
; entres : ES:DI  adresse de la chaine source
;           (termine par caractre 0)  
;           DS:SI  adresse de la destination
;****************************************************
strcpy   PROC   NEAR
         push   ax
         push   di
         push   si

strcp_1: mov    al,es:[di]
         mov    ds:[si],al
         cmp    al,0 
         je     strcp_2
         inc    di
         inc    si
         jmp    strcp_1
         ;-------------

strcp_2: pop    si
         pop    di
         pop    ax
         ret
strcpy   ENDP
