;*****************************************************************************;
;*****************************************************************************;
;**                               PARSE.INC                                 **;
;**                  Analyse et segmentation de la ligne de commande        **;
;**                                                                         **;
;**   Dernire modification : 28/05/93        Auteur : Jaques Belin         **;
;**       Cration                                                          **;
;**                                                                         **;
;*****************************************************************************;
;*****************************************************************************;
argc     DW     1                       ; nombre d'arguments
argv     DW     64 DUP (0)              ; tableau de pointeurs sur arguments  
psp      DW     (?)                     ; segment du psp

;****************************************************
; PARSE   : analyse la ligne de commande et cre une
;           table de paramtres de format identique
;            'argc' '*argv[]' du langage C
; entres : aucune
; retour  : argc, argv et psp initialiss
;           CX = nombre de paramtres
;           ES = segment du PSP
; Note : cette version ne gre pas argv[0] (nom du programme)
;****************************************************
parse    PROC   NEAR
         push   ax
         push   bx
         push   dx
         push   di
         push   ds
         push   si

         mov    ah,62h                  ; lecture adresse du PSP
         int    21h
         mov    [psp],bx

         ;stockage 'command' dans argv [0]

         mov    ax,[psp]                ; stockage adresse psp dans es
         mov    es,ax
         mov    bx,80h                  ; bx = ^ sur longueur ligne
         mov    di,bx
         inc    di                      ; di ^ sur 1er caractre
         xor    ch,ch
         mov    cl,es:[bx]              ; nombre de caractres dans cx
         cmp    cx,0                    ; si 0 caractres -> 0 param -> fin
         je     parse_6
         mov    dl,0                    ; inparam = 0
         mov    si,offset argv
         add    si,2                    ; position sur argv[1]
         
parse_1: mov    al,byte ptr es:[di]     ; caractre courant dans al
         cmp    al,22h                  ; si caractre '"'
         jne    parse_2
         xor    dl,0ffh                 ; inversion de inparam
         mov    byte ptr es:[di],0      ; on remplace par caract de fin
         jmp    parse_4                 ; on passe au caractre suivant
         ;-------------

parse_2: cmp    al," "                  ; si pas caractre espace
         jne    parse_4                 ; on passe au caractre suivant
         cmp    dl,0ffh                 ; est-on dans 1 par dlimit par '"'
         je     parse_4                 ; oui, on passe au caractre suivant
         mov    byte ptr es:[di],0      ; on remplace par caract de fin
         cmp    al,es:[di+1]            ; caractre suivant = espace ? 
         je     parse_4                 ; oui, on passe au caractre suivant
                                        ; le prochain caractre est le dbut
                                        ; d'un paramtre 
         mov    bx,di                  
         inc    bx                      ; bx = adresse du dbut du param
         cmp    byte ptr es:[bx],22h    ; si caractre suivant est un '"'
         jne    parse_3                   
         inc    bx                      ; on saute ce caractre
parse_3: cmp    byte ptr es:[bx],0dh    ; si retour chariot
         je     parse_5
         mov    [si],bx                 ; stockage adresse dans argv[]
         inc    si
         inc    si
         inc    word ptr [argc]

parse_4: inc    di                      ; caractre suivant
         loop   parse_1                 ; on boucle...
parse_5: mov    byte ptr es:[di],0      ; on remplace 'CR' par caract de fin
         mov    cx,[argc]
         dec    cx

parse_6: pop    si
         pop    ds
         pop    di
         pop    dx
         pop    bx
         pop    ax
         ret
parse    ENDP
