/*****************************************************************************/
/*****************************************************************************/
/**                              LIFBR.C                                    **/
/**              Affichage de fichiers LIF sur l'ecran du PC                **/
/**                                                                         **/
/**    Cration : 30/10/90               Auteur : JB                        **/
/**    Derniere modification : 07/06/92                                     **/
/**       passage de la table de conversion en ".h"                         **/
/**  NOTE : Ne pas oublier de compiler en mode LARGE ou COMPACT             **/
/*****************************************************************************/
/*****************************************************************************/
#include "lif.c"
#include "r8_pc850.h"

#if defined(__TURBOC__)        /* fonctions dpendant du type de compilateur */
#include "lif.tc"
#else
#include "lif.msc"
#endif


     /* table de conversion de caractres Roman8 vers IBM ( partir du 128e) */
unsigned char *r8_to_ibm=r8_pc850;



void main(int argc, char *argv[])
   {
    int    lif_drive;           /* numro du lecteur de disquette (0=A, 1=B) */
    int    err_entry=0;                /* flag d'erreur entre de parametres */
    LIFDIR dir;                 /* structure contenant l'entre du directory */
    int    pos_dir;                       /* numro de l'entre du directory */
    char   lif_name[11];                                   /* nom du fichier */
    int    type;                                  /* code du type de fichier */
    int    private, secure; /* codes de scurit et privatisation du fichier */
    GDH    gdh;                    /* structure contenant la date du fichier */
    long   imp1, imp2; /*codes specifiques aux types de fich. dans directory */
    int    long_file;          /* longueur du fichier LIF en enregistrements */
    int    first_sect;              /* premier enregistrement du fichier LIF */
    int    nb_char;                     /* nombre de caractres de la chaine */
    unsigned char far *dos_string;      /*chaine de caractres traite (DOS) */
    unsigned char c_fort;             /* poids fort de la longueur de chaine */
    unsigned char c_faible;         /* poids faible de la longueur de chaine */
    int    retour;             /*codes de retour des fct de lecture/ecriture */
    int    i;


    if(argc != 2)                                /* un paramtre obligatoire */
      {
       err_entry=1;
      }
    else
      {
       if((argv[1][0] < '0') || (argv[1][0] > '1')) /* numro lecteur oblig. */
          err_entry=1;
      }
    if(err_entry)                                     /* si erreur en entre */
      {
       fprintf(stderr, "usage : lifbr drive_number:infile\n");
       exit(-1);
      }

    lif_drive=(int) argv[1][0]-'0';               /* dcomposition paramtre */
    strcpy(lif_name, argv[1]+2);

                                      /* mise en forme du nom du fichier LIF */
    for(i=strlen(lif_name); i<10; i++)
       lif_name[i]=' ';
    lif_name[10]='\0';

    init_dsk();                                 /* initialisation de lecteur */

    retour=read_dsk(lif_drive, 0, buff_sect); /* controle validit disquette */
    if(retour)
      {
       fprintf(stderr, "Error : Not a LIF disk\n");
       fin(-1);
      }

                                            /* recherche entre du directory */
    retour=sch_dir(lif_drive, lif_name, &pos_dir, &dir);
    if(retour < 0)
      {
       fprintf(stderr, "file %s not found\n", lif_name);
       fin(-1);
      }

                                   /* dcomposition de l'entre du directory */
    break_dir(lif_name, &private, &secure, &type, &first_sect, &long_file,
                                       &gdh, &imp1, &imp2, &dir);
    if(type != TEXT)
      {
       fprintf(stderr, "%s: Not a TEXT file\n", lif_name);
       fin(-1);
      }

    dos_string=farmalloc(MAX_BUFFSIZE); /* allocation mmoire pour la chaine */

    curr_char=255;                   /* initialisation pointeur de caractere */
    curr_sect=first_sect;
                 /* lecture fichier jusqu' la recontre de 2 caractres 0xFF */
    while(((c_fort=read_char(lif_drive)) != 255) &&
          ((c_faible=read_char(lif_drive)) != 255))
      {
       nb_char=((int)c_fort<<8)+c_faible;  /* nombre caractres de la chaine */
       for(i=0; i<nb_char; i++)     /* pour tous les caracteres de la chaine */
         {
          if((dos_string[i]=read_char(lif_drive)) > 127)     /* si sup  127 */
             dos_string[i]=r8_to_ibm[dos_string[i]-128];  /*conversion en IBM*/
         }
       dos_string[nb_char]='\0';

       fprintf(stdout, "%s\n", dos_string);              /* affichage chaine */

       if(nb_char & 0x0001)                   /* si longueur chaine impaire, */
          read_char(lif_drive);                     /* on saute un caractre */
      }

    farfree(dos_string);                         /* libration de la mmoire */

    fin(0);                  /* fin du programme et rinitialisation lecteur */
   }
