/*****************************************************************************/
/*****************************************************************************/
/**                              LIFCP.C                                    **/
/**            Copie de fichiers TEXT (disquette LIF <-> MS/DOS)            **/
/**                                                                         **/
/**    Cration : 20/10/90               Auteur : JB                        **/
/**    Derniere modification : 12/06/92                                     **/
/**       correction bug sur first_sect si copie DOS->LIF avec option "-b"  **/
/**  NOTE : Ne pas oublier de compiler en mode LARGE ou COMPACT             **/
/*****************************************************************************/
/*****************************************************************************/
#include "lif.c"
#include "getopt.c"
#include "pc850_r8.h"
#include "r8_pc850.h"

#if defined(__TURBOC__)        /* fonctions dpendant du type de compilateur */
#include "lif.tc"
#else
#include "lif.msc"
#endif

      /* table de conversion de caractres IBM vers Roman8 ( partir du 128e)*/
unsigned char *ibm_r8=pc850_r8;

     /* table de conversion de caractres Roman8 vers IBM ( partir du 128e) */
unsigned char *r8_ibm=r8_pc850;

void main(int argc, char *argv[])
   {
    int    sens=0;                      /* 1 : LIF->MS/DOS   2 : MS/DOS->LIF */
    int    mode_bin=0;            /* traitement des fichiers en mode binaire */
    int    type_in=0, type_out=0; /* types des fichiers 1 : LIF   0 : MS-DOS */
    int    lif_drive;           /* numro du lecteur de disquette (0=A, 1=B) */
    int    err_entry=0;                /* flag d'erreur entre de parametres */
    FILE   *fp;                             /* descripteur du fichier MS/DOS */
    LIFDIR dir;                 /* structure contenant l'entre du directory */
    int    pos_dir;                       /* numro de l'entre du directory */
    char   lif_name[11], dos_name[50];                   /* nom des fichiers */
    int    type;                                  /* code du type de fichier */
    int    private, secure; /* codes de scurit et privatisation du fichier */
    GDH    gdh;                    /* structure contenant la date du fichier */
    long   imp1, imp2; /*codes specifiques aux types de fich. dans directory */
    int    long_file;          /* longueur du fichier LIF en enregistrements */
    int    first_sect;              /* premier enregistrement du fichier LIF */
    int    cl_dir;             /* si dplacement de fichier, ancienne entre */
    int    nb_char;                     /* nombre de caractres de la chaine */
    long   nb_chars;
    unsigned char far *dos_string;      /*chaine de caractres traite (DOS) */
    unsigned char out_char;                              /* caractre trait */
    unsigned char c_fort;             /* poids fort de la longueur de chaine */
    unsigned char c_faible;         /* poids faible de la longueur de chaine */
    int    retour, retour2;    /*codes de retour des fct de lecture/ecriture */
    long   chk_file;              /* variable de controle de fichier LIF/DOS */
    char   garbage[50];
    int    i;
    char   c;

    SW='-';
    while((c=(char) getopt(argc, argv, "b")) != EOF)
      {
       switch(c)
         {
          case 'b' : mode_bin = 1;                  /* copie en mode binaire */
                     break;

          case '?' : err_entry++;                               /* si erreur */
                     break;
         }
      }

    if(!err_entry)                                        /* si pas d'erreur */
      {
       if((argc-optind) == 2)            /* 2 noms de fichiers opbligatoires */
         {
                                                 /* dtection du fichier LIF */
          if((argv[optind][0] >= '0') && (argv[optind][0] <= '1'))
             type_in=1;
          if((argv[optind+1][0] >= '0') && (argv[optind+1][0] <= '1'))
             type_out=1;
          if((type_in+type_out) != 1)         /* 1 seul fichier LIF autoris */
             err_entry=1;
         }
       else
         {
          err_entry = 1;
         }
      }

    if(err_entry)                                               /* si erreur */
      {
       fprintf(stderr, "usage : lifcp [-b] drive_number:LIF_FILE dos_file\n");
       fprintf(stderr, "    or  lifcp [-b] dos_file drive_number:LIF_FILE\n");
       exit(-1);
      }

    if(type_in==1)                         /* determination du sens de copie */
      {
       sens=1;                                       /* sens LIF vers MS/DOS */
       lif_drive=(int) argv[optind][0]-'0';   /* selection numro de lecteur */
       strcpy(lif_name, argv[optind]+2);   /* acquisition nom de fichier LIF */
       strcpy(dos_name, argv[optind+1]);   /* acquisition nom de fichier DOS */
      }
    else
      {
       sens=2;
       lif_drive=(int) argv[optind+1][0]-'0';
       strcpy(lif_name, argv[optind+1]+2);
       strcpy(dos_name, argv[optind]);
      }

    for(i=strlen(lif_name); i<10; i++)     /* ajout d' espaces en fin de nom */
       lif_name[i]=' ';
    lif_name[10]='\0';

    init_dsk();                   /* initialisation de lecteur de disquettes */

    if(sens==1)                                  /* si copie LIF vers MS/DOS */
      {
                                /* recherche du fichier sur la disquette LIF */
       retour=sch_dir(lif_drive, lif_name, &pos_dir, &dir);
       if(retour < 0)
         {
          fprintf(stderr, "file %s not found\n", lif_name);
          fin(-1);
         }
                                   /* dcomposition de l'entre de directory */
       break_dir(lif_name, &private, &secure, &type, &first_sect, &long_file,
                                       &gdh, &imp1, &imp2, &dir);

       if(mode_bin)                              /* si copie en mode binaire */
         {
          fp=fopen(dos_name, "wb");   /* ouverture (ou cration) fichier DOS */

          chk_file=123123L;             /* criture de la valeur de controle */
          retour=fwrite(&chk_file, sizeof(long), 1, fp);
          if(retour != 1)                            /* si erreur d'criture */
            {
             fprintf(stderr, "Error : can't write %sn\n", dos_name);
             fin(-1);
            }

          retour=fwrite(&dir, 32, 1, fp);   /* criture entre de rpertoire */

          i=0;          /* copie des enregistrements LIF dans le fichier DOS */
          do
            {
             curr_sect=first_sect+i;
             retour2=read_dsk(lif_drive, curr_sect, (char *) buff_sect);
             if(retour2 == 0)
                retour=fwrite(buff_sect, 256, 1, fp);
             i++;
            }
          while((i != long_file) && (retour == 1) && (retour2 == 0));

          if(retour2 != 0)       /* si erreur de lecture de la disquette LIF */
            {
             fprintf(stderr, "I can't read the file %s\n", lif_name);
             fin(-1);
            }

          if(retour != 1)        /* si erreur d'ecriture dans le fichier DOS */
            {
             fprintf(stderr, "I can't write the file %s\n", dos_name);
             fin(-1);
            }
         }
       else                                         /* si copie en mode TEXT */
         {
          if(type != 1)                   /* si ce n'est pas un fichier TEXT */
            {
             fprintf(stderr, "%s: Not a TEXT file\n", lif_name);
             fin(-1);
            }

          fp=fopen(dos_name, "w");    /* ouverture (ou cration) fichier DOS */


          dos_string=farmalloc(MAX_BUFFSIZE); /*allocation mmoire pr chaine */

          curr_char=255;       /* initialisation position pointeur caractere */
          curr_sect=first_sect;
                                      /* lecture squentielle du fichier LIF */
          while(((c_fort=read_char(lif_drive)) != 255) &&
                ((c_faible=read_char(lif_drive)) != 255))
            {
             nb_char=((int)c_fort<<8)+c_faible; /*nbre de caract. de la ligne*/
             for(i=0; i<nb_char; i++)                 /* lecture de la ligne */
               {
                if((out_char=read_char(lif_drive)) > 127) /*conversion R8-IBM*/
                   out_char=r8_ibm[out_char-128];
                dos_string[i]=out_char;
               }
             dos_string[nb_char]='\0';
                                           /* criture ligne dans fichier DOS*/
             fprintf(fp, "%s\n", (char far *) dos_string); 

             if(nb_char & 0x0001)  /* si nombre impair de caract. dans ligne */
                read_char(lif_drive);             /* ..on saute un caractere */
            }
          farfree(dos_string);                         /* liberation mmoire */
         }
       fclose(fp);                                  /* fermeture fichier DOS */

       set_dos_gdh(dos_name, &gdh);                /* maj date du ficher dos */
      }
    else                                           /* si copie MS/DOS -> LIF */
      {
       if(mode_bin)                              /* si copie en mode binaire */
         {
          fp=fopen(dos_name, "rb");  /*ouverture fich. DOS en lecture+binaire*/
          if(fp == NULL)
            {
             fprintf(stderr, "file %s not found\n", dos_name);
             fin(-1);
            }

                      /* lecture de la valeur de controle de fichier LIF/DOS */
          retour=fread(&chk_file, sizeof(long), 1, fp);
          if(retour != 1)
            {
             fprintf(stderr, "I can't read %s\n", dos_name);
             fin(-1);
            }

                               /* si la valeur lue n'est pas le code attendu */
          if(chk_file != 123123L)
            {
             fprintf(stderr, "%s is not a LIF/DOS file\n", dos_name);
             fin(-1);
            }
                                        /* lecture de l'entre de rpertoire */
          retour=fread(&dir, 32, 1, fp);
          if(retour != 1)
            {
             fprintf(stderr, "I can't read %s\n", dos_name);
             fin(-1);
            }

          /* rcuperation de la longueur en enregistrements dans 'long_file' */
          break_dir(garbage, &private, &secure, &type, &first_sect, &long_file,
                                       &gdh, &imp1, &imp2, &dir);

                   /* recherche d'une place sur la disquette pour le fichier */
          first_sect=best_room(lif_drive, lif_name, long_file, &pos_dir,
                                                               &cl_dir);
          if(first_sect == -3)                  /* si disquette non reconnue */
            {
             fprintf(stderr, "Not a LIF disk\n");
             fin(-1);
            }
          if(first_sect == -1)                           /* si plus de place */
            {
             fprintf(stderr, "Not enough space for this file\n");
             fin(-1);
            }

          i=0; /* copie du fichier sur la disquette LIF (par enregistrement) */
          do
            {
             curr_sect=first_sect+i;
             retour=fread(buff_sect, 256, 1, fp);
             if(retour == 1)
                retour2=wrt_dsk(lif_drive, curr_sect, (char *) buff_sect);
             i++;
            }
          while((i != long_file) && (retour == 1) && (retour2 == 0));

          if(retour != 1)             /* si erreur de lecture du fichier DOS */
            {
             fprintf(stderr, "I can't read the file %s\n", dos_name);
             fin(-1);
            }

          if(retour2 != 0)      /* si erreur d'criture sur la disquette LIF */
            {
             fprintf(stderr, "I can't write the file %s\n", lif_name);
             fin(-1);
            }

                        /* reconstitution de la nouvelle entre de directory */
          build_dir(&dir, lif_name, private, secure, type, first_sect,
                 long_file, &gdh, imp1, imp2);
         }
       else                                         /* si copie en mode TEXT */
         {
          fp=fopen(dos_name, "r");       /* ouverture fichier DOS en lecture */
          if(fp == NULL)
            {
             fprintf(stderr, "file %s not found\n", dos_name);
             fin(-1);
            }
          dos_string=farmalloc(MAX_BUFFSIZE); /*allocation mmoire pr chaine */

                                              /* lecture totale du fichier DOS
                                     afin d'en dterminer la longueur exacte */
          i=0;
          nb_chars=0L;
          while(fgets((char far *) dos_string, 32767, fp) != NULL)
            {
             nb_char = strlen((char far *) dos_string);
             if(dos_string[nb_char-1] == 0x0A)
               {
                nb_char--;
               }
             nb_chars += (long) nb_char+2;
             /* prise en compte caractre suplmentaire si nb caract. impair */
             if(nb_char & 0x00000001)
                nb_chars++;
            }
          nb_chars += 2L;

          if(nb_chars % 256L)              /* longueur fichier LIF en enreg. */
             long_file=(int) ((nb_chars/256L)+1);
          else
             long_file=(int) (nb_chars/256L);

          fclose(fp);                            /* fermeture du fichier DOS */

                   /* recherche d'une place sur la disquette pour le fichier */
          first_sect=best_room(lif_drive, lif_name, long_file, &pos_dir,
                                                               &cl_dir);
          if(first_sect == -3)                  /* si disquette non reconnue */
            {
             fprintf(stderr, "Not a LIF disk\n");
             fin(-1);
            }
          if(first_sect == -1)                           /* si plus de place */
            {
             fprintf(stderr, "Not enough space for this file\n");
             fin(-1);
            }

          get_dos_gdh(dos_name, &gdh);    /* acquisition date du fichier DOS */

          fp=fopen(dos_name, "r");    /* ouverture du fichier DOS en lecture */

          curr_sect=first_sect;
          curr_char=0;
          while(fgets((char far *) dos_string, 32767, fp) != NULL) /*lecture */
            {
             nb_char=strlen((char far *) dos_string); /*nb caract. par ligne */
             if(dos_string[nb_char-1] == 0x0A)
               {
                nb_char--;
                dos_string[nb_char] = '\0';
               }
                                      /* ecriture de la longueur de la ligne */
             write_char(lif_drive, (unsigned char) nb_char / 256);
             write_char(lif_drive, (unsigned char) nb_char % 256);
             for(i=0; i<nb_char; i++)             /* ecriture des caractres */
               {
                out_char=dos_string[i];
                if(out_char > 127)            /* conversion caract IBM -> R8 */
                   out_char = ibm_r8[out_char-128];
                write_char(lif_drive, out_char);     /* ecriture dans buffer */
               }
             if(nb_char & 0x0001)          /* si nombre impair de caractres */
                write_char(lif_drive, 'A');     /* on en ajoute 1 quelconque */
            }

          farfree(dos_string);                         /* libration mmoire */
                                           /* rinitialisation fin du buffer */
          memset(buff_sect+curr_char, 0xFF, 256-curr_char);
                                    /* ecriture du contenu courant du buffer */
          wrt_dsk(lif_drive, curr_sect, (char *) buff_sect);

                                    /* construction de l'entre du directory */
          build_dir(&dir, lif_name, 0, 0, TEXT, first_sect, long_file,
                                                              &gdh, 0L, 0L);
         }
       wrt_dir(lif_drive, pos_dir, &dir);           /* ecriture du directory */

       if(cl_dir != -1)          /* si fichier 'dplac' sur la disquette... */
          clr_file(lif_drive, cl_dir);     /* ...on efface l'ancienne entre */

       fclose(fp);                               /* fermeture du fichier DOS */
      }
    fin(0);               /* rinitialisation du lecteur et fin du programme */
   }
