/*****************************************************************************/
/*****************************************************************************/
/**                            LIFDEL.C                                     **/
/**              Affichage de fichiers LIF sur l'ecran du PC                **/
/**                                                                         **/
/**    Cration : 30/12/90               Auteur : JB                        **/
/**    Derniere modification : 05/01/91                                     **/
/**       Ajout des commentaires                                            **/
/*****************************************************************************/
/*****************************************************************************/
#include "lif.c"

#if defined(__TURBOC__)        /* fonctions dpendant du type de compilateur */
#include "lif.tc"
#else
#include "lif.msc"
#endif

void main(int argc, char *argv[])
   {
    int    lif_drive;           /* numro du lecteur de disquette (0=A, 1=B) */
    int    err_entry=0;                /* flag d'erreur entre de parametres */
    LIFDIR dir;                 /* structure contenant l'entre du directory */
    int    pos_dir;                       /* numro de l'entre du directory */
    char   lif_name[11];                                   /* nom du fichier */
    int    retour;             /*codes de retour des fct de lecture/ecriture */
    int    i;


    if(argc != 2)                                /* un paramtre obligatoire */
      {
       err_entry=1;
      }
    else
      {
       if((argv[1][0] < '0') || (argv[1][0] > '1')) /* numro lecteur oblig. */
          err_entry=1;
      }
    if(err_entry)                                     /* si erreur en entre */
      {
       fprintf(stderr, "usage : lifdel drive_number:file\n");
       exit(-1);
      }

    lif_drive=(int) argv[1][0]-'0';               /* dcomposition paramtre */
    strcpy(lif_name, argv[1]+2);

                                      /* mise en forme du nom du fichier LIF */
    for(i=strlen(lif_name); i<10; i++)
       lif_name[i]=' ';
    lif_name[10]='\0';

    init_dsk();                                 /* initialisation de lecteur */

    retour=read_dsk(lif_drive, 0, buff_sect); /* controle validit disquette */
    if(retour)
      {
       fprintf(stderr, "Error : Not a LIF disk\n");
       fin(-1);
      }

                                            /* recherche entre du directory */
    retour=sch_dir(lif_drive, lif_name, &pos_dir, &dir);
    if(retour < 0)
      {
       fprintf(stderr, "file %s not found\n", lif_name);
       fin(-1);
      }
                                                   /* effacement de l'entre */
    retour=clr_file(lif_drive, pos_dir);
    if(retour < 0)
      {
       fprintf(stderr, "I can't delete %s\n", lif_name);
       fin(-1);
      }
    fin(0);
   }


